unit CapFunction;

interface

uses VideoCapture,Windows,CommonUnit,SysUtils,Graphics,DataItems,
     Classes,Grids,Controls,Registry,StdCtrls,Forms,spin;


Const  ColorBufSize=32;


       CARTON_MAXSIZE   = 120 ;
       CARTON_MINSIZE   = 25  ;
       CARTON_DEFCURSORX= 160 ;
       CARTON_DEFCURSORY= 120 ;

       VP_BLACK=0;
       VP_WHITE=$1f;

       VP_VideoWidth =320;
       VP_VideoHeight=240;

type

 TColorFrequence = Class(TObject)
  private
  FcolorBuf: array[0..ColorBufSize-1]  of LONGWORD;

  fVideoBox:TVideoCapture;
  fFrameBMP:TBitmap;



  fBounds:TRect;

  fMinThr:BYTE;
  fMaxThr:BYTE;
  fMidThr:BYTE;
  fHiBen :BYTE;
  fCommbe:BYTE;

  FAutoTHR:BOOLean;

  FOnProgress: TOnProgressMessage ;


  procedure setBounds(R:TRECT);
  Function  GetColorBuf(index:integer):LONGWORD;
  procedure SetMidThr(Value:BYTE);

  procedure GetCOLORPALETE(left,top,W,H:integer;Graphic: HBitmap);




  procedure GetHistogrom;

  procedure GetCommbe;
  procedure GetMidThr;

  public
      constructor Create(aVideoBox:TVideoCapture;aFrameBMP:TBitmap);
      procedure   ColorStatistic;
      property ColorBuf[index:integer]:LONGWORD read GetColorBuf;

      procedure DrawBW;

  published
        property Bounds: TRect   read fBounds  write setBounds ;
        property THR: BYTE       read fMidThr  write SetMidThr ;
        property AutoTHR:BOOLean read FAutoTHR write  FAutoTHR;

        property OnProgress: TOnProgressMessage  read FOnProgress write FOnProgress;

  end;





   type
      TCartonDataChangle=(ccALL,ccCURSORX,ccCURSORY,ccSIZEX,ccSIZEY,ccCOLOR,ccAUTOTHR,ccTHR,ccCARTONTYPE);
      TOnCartonDataChangle  = procedure(c:TCartonDataChangle;value:pointer) of object;


     PSize =^TSize;
     TSize = record
       cx: Integer;
       cy: Integer;
     end;


    TCartonType=(ctCircular,ctCROSS,ctCROSSCircular);

    PCartonDatas = ^TCartonDatas;
    TCartonDatas = record
      CursorPoint : TPoint;
      Size        : TSize;
      TargetColor : BYTE;
      AutoTHRFlag : Boolean;
      THR         : BYTE;
      item1       : integer;
      item2       : integer;
      item3       : integer;
      item4       : integer;
      CartonType  : TCartonType;
    end;




    //........................................................
    PCartonObject = ^TCartonObject;
    TCartonObject =class(TDataItem)
    public
     constructor Create(Collection: TCollection); override;
     destructor Destroy; override;
     Procedure  Inflated(s:TSize);         Overload;
     Procedure  Inflated(cx,cy:Integer);   Overload;
     Procedure  Offset(p:tpoint);          Overload;
     Procedure  Offset(cx,cy:integer);     Overload;
     procedure  OnShowCarton(Sender:TObject);
     procedure  Assign(Source: TPersistent); override;

     Function writeToStringsGrid(g:TStringGrid):Boolean; override;
     Function ReadFromStringsGrid(g:TStringGrid):Boolean; override;

     Function  GetEditClass(PropertiesName:string):TEditorClass; override;
     procedure SetEditOption(PropertiesName:string;Editor:TWinControl); override;

     procedure ShowCartonTypePanel;
     Procedure ShowCursorPanel ;
     Procedure ShowSizePanel ;
     Procedure ShowColorPanel ;
     procedure ShowAutoTHRPanel ;
     Procedure ShowTHRPanel ;

     procedure DrawToClientPanel(b:TBitmap);


    protected

     procedure WriteProperties(var Reg:TRegistry); override;
     procedure ReadProperties(var Reg:TRegistry);  override;
     Function  GetCanEdit:Boolean; override;

    private
     FCartonDatas : TCartonDatas;
     FVideoCanvas : TVideoCapture;


     fCartonTypePanel : TLabel;
     fCursorPanel     : TLabel ;
     fSizePanel       : TLabel ;
     fColorPanel      : TLabel ;
     FAutoTHRPanel    : TLabel ;
     fTHRPanel        : TLabel ;
     fClientPanel     : TForm  ;

     fBitmap:TBitmap;

     FOnCDataChangle:  TOnCartonDataChangle ;


      procedure SetCartonData(c:TCartonDatas);
      procedure SetCartonType(c:TCartonType);
      Procedure setSize(s:TSize);
      Procedure setColor(c:BYTE);
      procedure setCursorPoint(c:TPoint);
      procedure SetAutoTHRFlag(t:Boolean);
      procedure SetTHR(t:BYTE);


      function  getRect:TRect;
      procedure RectToCarton(r:TRect);
      Procedure setVideoCanvas(c:TVideoCapture);
      procedure ShowCarton(ClienterPanel:TForm;IsVisible:Boolean);

     published

      property CartonDatas: TCartonDatas read FCartonDatas             write  SetCartonData;
      property CartonType : TCartonType  read FCartonDatas.CartonType  write  SetCartonType;
      property Size: TSize               read FCartonDatas.Size        write  SetSize;
      property Color:BYTE                read FCartonDatas.TargetColor write  SetColor;
      property CursorPoint:TPoint        read FCartonDatas.CursorPoint write  SetCursorPoint;
      property AutoTHR:Boolean           read FCartonDatas.AutoTHRFlag write  SetAutoTHRFlag;
      property THR:BYTE                  read FCartonDatas.THR         write  SetTHR;


      property CartonRect:TRect  read getRect   write RectToCarton;
      Property VideoCanvas:TVideoCapture read FVideoCanvas   write setVideoCanvas;


      property OnCDataChangle: TOnCartonDataChangle read FOnCDataChangle write FOnCDataChangle ;


      property CartonTypePanel :TLabel  read fCartonTypePanel write fCartonTypePanel;
      property CursorPanel  : TLabel   read FCursorPanel  write FCursorPanel   ;
      property SizePanel    : TLabel   read FSizePanel    write FSizePanel     ;
      property ColorPanel   : TLabel   read FColorPanel   write FColorPanel    ;
      property AutoTHRPanel : TLabel   read FAutoTHRPanel write FAutoTHRPanel    ;
      property THRPanel     : TLabel   read FTHRPanel     write FTHRPanel ;
      property ClientPanel  : TForm  read FClientPanel    write FClientPanel;

      property Bitmap:TBitmap read fBitmap;


    end;
//.....................................................................




    PCartonGroup = ^TCartonGroup;
    TCartonGroup =class(TDataItem)
      public

       constructor Create(Collection: TCollection); override;
       destructor  Destroy; override;
       function  CCD(index:Integer):TCartonObject;
      private
       FOnProgressMessage: TOnProgressMessage;
       FIsTmpData:Boolean;
      protected
         Function  GetCanEdit:Boolean; override;
      published
       property  OnProgressMessage:TOnProgressMessage read  FOnProgressMessage write   FOnProgressMessage ;
    end;





var
   CartonGroups:TCartonGroup;


implementation

//....................................................

function VPColorToStr(Value:BYTE):string;
begin
  if VP_BLACK=Value then result:='BLACK'
  else                   result:='WHITE';
end;


function StrToVPColor(Value:string):BYTE;
begin
 if strcomp(pchar(value),'BLACK')=0 then result:=VP_BLACK
 else                                    result:=VP_WHITE;

end;





//....................................................
{TCartonObject}
constructor TCartonObject.Create(Collection: TCollection);

begin
  inherited Create(Collection);

  FCartonDatas.CursorPoint.x:= CARTON_DEFCURSORX;
  FCartonDatas.CursorPoint.y:= CARTON_DEFCURSORY;
  FCartonDatas.Size.cx:=CARTON_MINSIZE;
  FCartonDatas.Size.cy:=CARTON_MINSIZE;
  FCartonDatas.TargetColor:= 0 ;
  FCartonDatas.AutoTHRFlag:=TRUE;
  FCartonDatas.THR:=16;
  FVideoCanvas := nil ;
  FOnCDataChangle:=nil;

 fCartonTypePanel:=nil;
 fCursorPanel  := nil ;
 fSizePanel    := nil ;
 fColorPanel   := nil ;
 FAutoTHRPanel := nil;
 fTHRPanel     := nil ;
 FClientPanel  := nil ;


 fBitmap:=TBitmap.Create;
 fBitmap.Width :=320;
 fBitmap.Height:=240;
 fBitmap.PixelFormat:=pf16bit;

end;


destructor TCartonObject.Destroy;
begin

 fBitmap.Free;
 inherited Destroy;
end;


procedure TCartonObject.SetCartonData(c:TCartonDatas);
begin


  if (c.TargetColor = VP_WHITE)  OR (c.TargetColor=VP_BLACK) then
      FCartonDatas.TargetColor:=c.TargetColor;

  if (c.CursorPoint.x >=0) AND (c.CursorPoint.x<VP_VideoWidth)  then
     FCartonDatas.CursorPoint.x:=c.CursorPoint.x;

  if (c.CursorPoint.y >=0) AND (c.CursorPoint.y<VP_VideoHeight) then
     FCartonDatas.CursorPoint.y:=c.CursorPoint.y;

  if (c.Size.cx>=CARTON_MINSIZE ) AND (c.Size.cx<=CARTON_MAXSIZE) then
     FCartonDatas.Size.cx:=c.Size.cx;

  if (c.Size.cy>=CARTON_MINSIZE ) AND (c.Size.cy<=CARTON_MAXSIZE) then
     FCartonDatas.Size.cy:=c.Size.cy;

  FCartonDatas.AutoTHRFlag:=c.AutoTHRFlag;
  FCartonDatas.THR:=c.THR;

  FCartonDatas.item1:=c.item1;
  FCartonDatas.item2:=c.item2;
  FCartonDatas.item3:=c.item3;
  FCartonDatas.item4:=c.item4;

  FCartonDatas.CartonType:=c.CartonType;


  if Assigned(OnCDataChangle) then
   FOnCDataChangle(ccALL,Pointer(@FCartonDatas));

end;


Procedure TCartonObject.Inflated(s:TSize);

begin

     s.cx:= FCartonDatas.Size.cx+s.cx;
     s.cy:= FCartonDatas.Size.cy+s.cy;

     if (s.cx <CARTON_MINSIZE) OR (s.cx > CARTON_MAXSIZE) then  exit;
     if (s.cy <CARTON_MINSIZE) OR (s.cy > CARTON_MAXSIZE) then  exit;

     Size:=s;

end;

Procedure TCartonObject.Inflated(cx,cy:Integer);
Var
    s:TSize;
begin
     s.cx:=cx ;
     s.cy:=cy ;
     Inflated(s);
end;




Procedure  TCartonObject.Offset(p:tpoint);
begin
  p.x:= CursorPoint.x + p.x ;
  p.y:= CursorPoint.y + p.y ;
  CursorPoint:=p;
end;

Procedure  TCartonObject.Offset(cx,cy:integer);
var
p:TPoint;
begin
  p.x:=cx;
  p.y:=cy;
  Offset(p);
end;

procedure TCartonObject.SetCartonType(c:TCartonType);
begin
 if c<> FCartonDatas.Cartontype then
 begin
   ShowCarton(FClientPanel ,FALSE);
   FCartonDatas.Cartontype:=c;
   ShowCarton(FClientPanel ,TRUE);

   showCartontypePanel;
   if Assigned(FOnCDataChangle) then FOnCDataChangle(ccCARTONTYPE,@FCartonDatas.Cartontype);

 end;



end;


procedure TCartonObject.setCursorPoint(c:TPoint);
var
chang:boolean;
tmpt:TPoint;
begin
   tmpt:=FCartonDatas.CursorPoint;
   chang:=FALSE;
   if (c.x >=0) AND (c.x<VP_VideoWidth) and (c.x <> FCartonDatas.CursorPoint.x) then
   begin
     FCartonDatas.CursorPoint.x:=c.x;
     if Assigned(FOnCDataChangle) then FOnCDataChangle(ccCURSORX,@FCartonDatas.CursorPoint.x);
     chang:=true;
   end;

  if (c.y >=0) AND (c.y<VP_VideoHeight) and (c.y <> FCartonDatas.CursorPoint.y ) then
  begin
     FCartonDatas.CursorPoint.y:=c.y;
     if Assigned(FOnCDataChangle) then FOnCDataChangle(ccCURSORY,@FCartonDatas.CursorPoint.y);
     chang:=true;
  end;

  if chang then
  begin
   FCartonDatas.CursorPoint:=tmpt;
   ShowCarton(FClientPanel ,FALSE);
   FCartonDatas.CursorPoint:=c;
   ShowCarton(FClientPanel ,TRUE);

   showcursorpanel;
  end;


end;


Procedure TCartonObject.setSize(s:TSize);
var
chang:boolean;
tmpt:TSize;
begin
    tmpt:=FCartonDatas.Size;
    chang:=False;
     if (s.cx <CARTON_MINSIZE) OR (s.cx > CARTON_MAXSIZE) then  exit;
     if (s.cy <CARTON_MINSIZE) OR (s.cy > CARTON_MAXSIZE) then  exit;

     if s.cx <>  FCartonDatas.Size.cx then
     begin
       FCartonDatas.Size.cx:= s.cx;
       if Assigned(FOnCDataChangle) then FOnCDataChangle(ccSIZEX,@FCartonDatas.Size.cx);
       chang:=TRUE;
     end;
     if s.cy <>  FCartonDatas.Size.cy then
     begin
       FCartonDatas.Size.cy:= s.cy;
      if Assigned(FOnCDataChangle) then FOnCDataChangle(ccSIZEY,@FCartonDatas.Size.cy);
       chang:=TRUE;
     end;

    if chang then
    begin
      FCartonDatas.Size:=tmpt;
      ShowCarton(FClientPanel ,FALSE);
      FCartonDatas.Size:=s;
      ShowCarton(FClientPanel ,TRUE);

     showSizePanel;

    end;

end;

Procedure TCartonObject.setColor(c:BYTE);
begin
   if ( (c=VP_BLACK) OR (c=VP_WHITE) ) and (c <> FCartonDatas.TargetColor) then
    begin
     FCartonDatas.TargetColor:=c;

      if Assigned(FOnCDataChangle) then FOnCDataChangle(ccColor,@FCartonDatas.TargetColor);

      showColorPanel;
    end;

end;


procedure TCartonObject.SetAutoTHRFlag(t:Boolean);
begin
  if t <> FCartonDatas.AutoTHRFlag then
  begin
   if t=FALSE then
   begin
     FCartonDatas.AutoTHRFlag:=FALSE;
   end
   else
   begin
    FCartonDatas.AutoTHRFlag:=TRUE;
   end;

   if Assigned(FOnCDataChangle) then FOnCDataChangle(ccAUTOTHR,@FCartonDatas.AutoTHRFlag);

   ShowAutoTHRPanel;

  end;



end;
procedure TCartonObject.SetTHR(t:BYTE);
var
i:integer;
begin

 if FCartonDatas.CartonType=ctCROSSCircular then
 begin
   if t <> FCartonDatas.THR   then
  begin
   FCartonDatas.THR  :=t;
   i:=FCartonDatas.THR;
   if Assigned(FOnCDataChangle) then FOnCDataChangle(ccTHR,@i);
    showTHRPanel;
  end;

 end
 else
 begin


  if ( (t <> FCartonDatas.THR)  and (t <= 31) ) and (t<>FCartonDatas.THR) then
  begin
   FCartonDatas.THR  :=t;
   i:=FCartonDatas.THR;
   if Assigned(FOnCDataChangle) then FOnCDataChangle(ccTHR,@i);
    showTHRPanel;
  end;

 end;



end;


procedure TCartonObject.ShowCartonTypePanel;
var
s:string;
begin
 if assigned(fCartonTypePanel) then
 begin
  case FCartonDatas.CartonType of
   ctCircular:           s:='';
   ctCROSS:              s:='';
   ctCROSSCircular:      s:='';
  end;
   fCartonTypePanel.Caption:=s;
 end;


end;

Procedure TCartonObject.ShowCursorPanel;
begin
if assigned(fCursorPanel)  then
begin


 fCursorPanel.Caption:=IntToStr(FCartonDatas.CursorPoint.x)+','+IntToStr(FCartonDatas.CursorPoint.y);
end;
end;

Procedure TCartonObject.ShowSizePanel ;
begin
if Assigned(fSizePanel) then
begin
 fSizePanel.Caption:=InttoStr(FCartonDatas.Size.cx);
end;
end;

Procedure TCartonObject.ShowColorPanel ;
begin
if Assigned(fColorPanel)    then
begin
 if  FCartonDatas.TargetColor=VP_BLACK  then
     fColorPanel.Caption:='BLACK'
 else
     fColorPanel.Caption:='WHITE';
end;
end;


Procedure TCartonObject.ShowTHRPanel ;
begin
if fTHRPanel     <> nil  then
begin
  fTHRPanel.Caption:=INttostr(FCartonDatas.THR);
end;

end;

Procedure TCartonObject.ShowAutoTHRPanel ;
var
s:string;
begin

 if FAutoTHRPanel <> nil then
 begin
  if FCartonDatas.AutoTHRflag then
     s:='۰'
  else
     s:='Tw';
  fAutoTHRPanel.Caption:=s;

 end;


end;




function  TCartonObject.getRect:TRect;
Var
   r:TRect;
begin
  if (FCartonDatas.CartonType=ctCircular) then
  begin
   r.Left   := FCartonDatas.CursorPoint.x - FCartonDatas.Size.cx;
   r.Right  := FCartonDatas.CursorPoint.x + FCartonDatas.Size.cx;
   r.Top    := FCartonDatas.CursorPoint.y - FCartonDatas.Size.cy;
   r.Bottom := FCartonDatas.CursorPoint.y + FCartonDatas.Size.cy;
  end
  else
  begin
   r.Left   := 0;
   r.Right  := 511;
   r.Top    := 0;
   r.Bottom := 399;
  end;
  Result:=r;

end;

procedure TCartonObject.RectToCarton(r:TRect);
begin

 if (FCartonDatas.CartonType=ctCircular) then
 begin

   FcartonDatas.Size.cx:=(r.Right-r.Left) shr 1;
   FCartonDatas.CursorPoint.x:=r.Left + FCartonDatas.Size.cx;

   FcartonDatas.Size.cy:=(r.Bottom-r.Top) shr 1;
   FCartonDatas.CursorPoint.y:=r.Top + FCartonDatas.Size.cy;

 end;


end;

Procedure TCartonObject.setVideoCanvas(c:TVideoCapture);
begin
   FVideoCanvas:=c;
end;

procedure TCartonObject.OnShowCarton(Sender:TObject);
var
s:TForm;
begin
 s:= Sender as  TForm;
 ShowCarton(s,s.Visible);

end;

procedure  TCartonObject.ShowCarton(ClienterPanel:TForm;IsVisible:Boolean);
var
Canvas:TCanvas;
R:Trect;
y:integer;
begin

if  ClienterPanel.Visible=False then exit;

  





 Canvas:= ClienterPanel.Canvas;

 canvas.Brush.Style:=bsClear;
 Canvas.Pen.Style:=psSolid;
 Canvas.Pen.Color:=RGB(0,$ff,$FF);
 canvas.Pen.Mode:=pmXor;
 canvas.Pen.Width:=2;


 if FCartonDatas.CartonType=ctCircular then
 begin
 R:=getRect;

 y:=r.Top;
 r.Top    :=239-r.Bottom ;
 r.Bottom :=239-y ;
 y:=239-FCartonDatas.CursorPoint.y;

 Canvas.Ellipse(R);
 Canvas.MoveTo(FCartonDatas.CursorPoint.x-10 ,y);
 Canvas.LineTo(FCartonDatas.CursorPoint.x+10 ,y);
 Canvas.MoveTo(FCartonDatas.CursorPoint.x,y-10);
 Canvas.LineTo(FCartonDatas.CursorPoint.x,y+10);
 Canvas.MoveTo(0,y);
 Canvas.LineTo(R.Left,y);
 Canvas.MoveTo(R.Right,y);
 Canvas.LineTo(VP_VideoWidth-1,y);
 Canvas.MoveTo(FCartonDatas.CursorPoint.x,0);
 Canvas.LineTo(FCartonDatas.CursorPoint.x,R.Top);
 Canvas.MoveTo(FCartonDatas.CursorPoint.x,R.Bottom);
 Canvas.LineTo(FCartonDatas.CursorPoint.x,VP_VideoHeight-1);
 end
 else
 if FCartonDatas.CartonType=ctCROSS then
 begin
   Canvas.MoveTo(FCartonDatas.CursorPoint.x,0);
   Canvas.LineTo(FCartonDatas.CursorPoint.x,239);
   Canvas.MoveTo(0  ,FCartonDatas.CursorPoint.y);
   Canvas.LineTo(319,FCartonDatas.CursorPoint.y);
 end
 else
 if FCartonDatas.CartonType=ctCROSSCircular then
 begin
 {
   Canvas.MoveTo(FCartonDatas.CursorPoint.x,0);
   Canvas.LineTo(FCartonDatas.CursorPoint.x,399);
   Canvas.MoveTo(0  ,FCartonDatas.CursorPoint.y);
   Canvas.LineTo(511,FCartonDatas.CursorPoint.y);
 }


  with FCartonDatas do
  begin
      Canvas.MoveTo(0                    ,CursorPoint.y-Size.cy);
      Canvas.LineTo(CursorPoint.x-Size.cx,CursorPoint.y-Size.cy);

      Canvas.MoveTo(CursorPoint.x+Size.cx,CursorPoint.y-Size.cy);
      Canvas.LineTo(319                  ,CursorPoint.y-Size.cy);

      Canvas.MoveTo(0                    ,CursorPoint.y+Size.cy);
      Canvas.LineTo(CursorPoint.x-Size.cx,CursorPoint.y+Size.cy);

      Canvas.MoveTo(CursorPoint.x+Size.cx,CursorPoint.y+Size.cy);
      Canvas.LineTo(319                  ,CursorPoint.y+Size.cy);


      Canvas.MoveTo(CursorPoint.x-Size.cx,0);
      Canvas.LineTo(CursorPoint.x-Size.cx,CursorPoint.y-Size.cy);

      Canvas.MoveTo(CursorPoint.x-Size.cx,CursorPoint.y+Size.cy);
      Canvas.LineTo(CursorPoint.x-Size.cx,239);


      Canvas.MoveTo(CursorPoint.x+Size.cx,0);
      Canvas.LineTo(CursorPoint.x+Size.cx,CursorPoint.y-Size.cy);

      Canvas.MoveTo(CursorPoint.x+Size.cx,CursorPoint.y+Size.cy);
      Canvas.LineTo(CursorPoint.x+Size.cx,239);


  end;


 end;







// ClienterPanel.VPSCreen.ReleasePanelRegion(Canvas.ClipRegion);
// Canvas.ClipRegion:=0;






end;


procedure TCartonObject.DrawToClientPanel(b:TBitmap);
var
s:Windows.PSize;
r:TRECT;
begin

 if assigned( ClientPanel ) then
 begin

  r.Left :=0;
  r.Right:=Bitmap.Width;
  r.Top:=0;
  r.Bottom:=Bitmap.Height;
//  Bitmap.Canvas.FillRect(r);

//  ClientPanel.Canvas.Draw(0,0,Bitmap);
  ClientPanel.Canvas.CopyRect(ClientPanel.ClientRect,Bitmap.Canvas,r);

 end;


end;




procedure TCartonObject.WriteProperties(var Reg:TRegistry);
begin
 try
  Reg.WriteInteger('CursorX',FCartonDatas.CursorPoint.x);
  Reg.WriteInteger('CursorY',FCartonDatas.CursorPoint.y);
  Reg.WriteInteger('SIZEW'  ,FCartonDatas.Size.cx);
  Reg.WriteInteger('SIZEH'  ,FCartonDatas.Size.cy);
  Reg.WriteInteger('COLOR'  ,FCartonDatas.TargetColor);
  Reg.WriteBool('AUTOTHR',FCartonDatas.AutoTHRFlag);
  Reg.WriteInteger('THR',integer(FCartonDatas.THR));

  Reg.WriteInteger('ITEM1',FCartonDatas.Item1);
  Reg.WriteInteger('ITEM2',FCartonDatas.Item2);
  Reg.WriteInteger('ITEM3',FCartonDatas.Item3);
  Reg.WriteInteger('ITEM4',FCartonDatas.Item4);

  reg.WriteInteger('TYPE',integer(FCartondatas.CartonType));
 except

 end;

end;


procedure TCartonObject.ReadProperties(var Reg:TRegistry);
Var
   c   :TCartonDatas;
begin
try
 c.CursorPoint.x:= Reg.ReadInteger('CursorX');
 c.CursorPoint.y:= Reg.ReadInteger('CursorY');

 c.Size.cx      := Reg.ReadInteger('SIZEW'  );
 c.Size.cy      := Reg.ReadInteger('SIZEH'  );
 c.TargetColor  := Reg.ReadInteger('COLOR'  );
 c.AutoTHRFlag  := Reg.ReadBool('AUTOTHR');
 c.THR          := BYTE(Reg.ReadInteger('THR'));

 c.Item1:= Reg.ReadInteger('ITEM1');
 c.Item2:= Reg.ReadInteger('ITEM2');
 c.Item3:= Reg.ReadInteger('ITEM3');
 c.Item4:= Reg.ReadInteger('ITEM4');

 c.CartonType   :=TCartonType(reg.ReadInteger('TYPE'));

 CartonDatas:=c;
except

end;


end;


Function TCartonObject.writeToStringsGrid(g:TStringGrid):Boolean;
begin
 g.Rowcount:=12;

 g.cells[0,1]:='Cursor X';  g.cells[1,1]:=IntToStr(CartonDatas.CursorPoint.x );
 g.cells[0,2]:='Cursor Y';  g.cells[1,2]:=IntToStr(CartonDatas.CursorPoint.y );
 g.cells[0,3]:='Size';      g.cells[1,3]:=IntToStr(CartonDatas.Size.cx)       ;
 g.cells[0,4]:='Color';     g.cells[1,4]:=VPColorToStr(CartonDatas.TargetColor)  ;
 g.cells[0,5]:='Auto THR';  g.cells[1,5]:=BooleanToStr(CartonDatas.AutoTHRFlag) ;
 g.cells[0,6]:='THR';       g.cells[1,6]:=IntToStr(CartonDatas.THR)           ;
 g.cells[0,7]:='TYPE';      g.cells[1,7]:=IntToStr(integer(CartonDatas.CartonType)) ;


 g.cells[0,8] :='Item1';    g.cells[1,8] :=IntToStr(CartonDatas.item1) ;
 g.cells[0,9] :='Item2';    g.cells[1,9] :=IntToStr(CartonDatas.item2) ;
 g.cells[0,10]:='Item3';    g.cells[1,10]:=IntToStr(CartonDatas.item3) ;
 g.cells[0,11]:='Item4';    g.cells[1,11]:=IntToStr(CartonDatas.item4) ;


 result:=TRUE;
end;

Function TCartonObject.ReadFromStringsGrid(g:TStringGrid):Boolean;
Var
   c   :TCartonDatas;
begin
try
 c.CursorPoint.x:=StrToInt (g.cells[1,1]);
 c.CursorPoint.y:=StrToInt (g.cells[1,2]);

 c.Size.cx      :=StrToInt (g.cells[1,3]);
 c.size.cy:=c.Size.cx;
 c.TargetColor  :=StrToVPColor(g.cells[1,4])  ;
 c.AutoTHRFlag  :=StrToBoolean(g.cells[1,5])  ;
 c.THR          :=Byte(StrToInt(g.cells[1,6]) ) ;

 C.CartonType   :=TCartonType(StrToint(g.cells[1,7]));

 C.item1:=StrToint(g.cells[1,8]  );
 C.item2:=StrToint(g.cells[1,9]  );
 C.item3:=StrToint(g.cells[1,10] );
 C.item4:=StrToint(g.cells[1,11] );

 CartonDatas:=c;
except

end;

 result:=TRUE;
end;

Function  TCartonObject.GetEditClass(PropertiesName:string):TEditorClass;
begin
 if strcomp(Pchar(PropertiesName),'Cursor X')=0 then
   result:=TSpinEdit
 else
 if strcomp(Pchar(PropertiesName),'Cursor Y')=0 then
   result:=TSpinEdit
 else
 if strcomp(Pchar(PropertiesName),'Size')=0 then
   result:=TSpinEdit
 else
 if strcomp(Pchar(PropertiesName),'Color')=0 then
    result:=TComboBOX
 else
 if strcomp(Pchar(PropertiesName),'Auto THR')=0 then
     result:=TComboBOX
 else
 if strcomp(Pchar(PropertiesName),'THR')=0 then
    result:=TSpinEdit
 else
    result:=TEdit;

end;

procedure TCartonObject.SetEditOption(PropertiesName:string;Editor:TWinControl);
begin

 if strcomp(Pchar(PropertiesName),'Cursor X')=0 then
 begin
   TSpinEdit(Editor).MaxValue:=VP_VideoWidth-1;
   TSpinEdit(Editor).MinValue:=0;
 end
 else
 if strcomp(Pchar(PropertiesName),'Cursor Y')=0 then
 begin
   TSpinEdit(Editor).MaxValue:=VP_VideoHeight-1;
   TSpinEdit(Editor).MinValue:=0;
 end
 else
 if strcomp(Pchar(PropertiesName),'Size')=0 then
 begin
   TSpinEdit(Editor).MaxValue:=  CARTON_MAXSIZE  ;
   TSpinEdit(Editor).MinValue:=  CARTON_MINSIZE  ;
 end
 else
 if strcomp(Pchar(PropertiesName),'Color')=0 then
 begin
    TComboBOX(editor).items.add(VPCOLORTOSTR(VP_BLACK));
    TComboBOX(editor).items.add(VPCOLORTOSTR(VP_WHITE));
 end
 else
 if strcomp(Pchar(PropertiesName),'Auto THR')=0 then
 begin
    TComboBOX(editor).items.add(BOOLEANTOSTR(FALSE));
    TComboBOX(editor).items.add(BOOLEANTOSTR(TRUE));
 end
 else
 if strcomp(Pchar(PropertiesName),'THR')=0 then
 begin
   TSpinEdit(Editor).MaxValue:=31;
   TSpinEdit(Editor).MinValue:=0 ;
 end
 else  inherited SetEditOption(PropertiesName,Editor);



end;



procedure TCartonObject.Assign(Source: TPersistent);
begin
 if Source is TCartonObject then
  begin
    FName := TCartonObject(Source).FName;
    FSubItems.Assign(TCartonObject(Source).FSubItems);
    CartonDatas:= TCartonObject(Source).CartonDatas;
  end
  else inherited Assign(Source);



end;


Function  TCartonObject.GetCanEdit:Boolean;
begin
 result:=False;
end;





//...................................................
constructor TCartonGroup.Create(Collection: TCollection);
begin
  inherited Create(Collection);

  if Assigned( CartonGroups )=FALSE then
  begin
    CartonGroups:=self;
    FIsTmpData:=FALSE;
  end
  else FIsTmpData:=TRUE;

   FName:='Carton Group';
   FSubItems.Name:='Carton Datas';
   FSubItems.SetDataItemClass(TCartonObject);
   FOnProgressMessage:=nil;
end;

destructor TCartonGroup.Destroy;
begin

if  FIsTmpData=FALSE then
begin

end;

 inherited Destroy;
end;

function  TCartonGroup.CCD(index:Integer):TCartonObject;
var
s:string;
begin
 s:='CCD'+inttostr(index);
 result:= self.FindDataItem(s) as TCartonObject;
end;


Function  TCartonGroup.GetCanEdit:Boolean;
begin
 if  inherited GetCanEdit then
 begin
  Result:=TRUE;
 end
 else
 begin
   Result:=False;
 end;


end;





//..................................................
//IN EAX=COLORBUF ADDRESS
PROCEDURE COLOBUFSMOOTHEN(colorbuf:PLONGWORD);
VAR
   TMPCOLORBUF:ARRAY[0..31] OF LONGWORD;
ASM
         PUSH ECX
         PUSH EDI
         PUSH ESI
         PUSH EAX
         PUSH EDX
         PUSH EBX

         MOV  EDI,colorbuf
         ADD  EDI,4

         LEA  ESI,TMPCOLORBUF
         MOV  DWORD PTR [ESI],0
         ADD  ESI,4


         MOV  ECX,30
@SMOOTHEN1:
         MOV EAX,[EDI-4]
         ADD EAX,[EDI]
         ADD EAX,[EDI+4]
         MOV  EBX,3
         CDQ
         IDIV EBX
         MOV [ESI],EAX
         ADD ESI,4
         ADD EDI,4
         LOOP @SMOOTHEN1

         CLD

         SUB  EDI,120
         SUB  ESI,120
         MOV  ECX,30
         REP  MOVSD

         POP  EBX
         POP  EDX
         POP  EAX
         POP  ESI
         POP  EDI
         POP  ECX
END;






constructor TColorFrequence.Create(aVideoBox:TVideoCapture;aFrameBMP:TBitmap);
begin

 fVideoBox:=aVideoBox;
 fFrameBmp:=aFrameBMP;

 fMinThr:=0;
 fMaxThr:=0;
 fMidThr:=0;
 fHiBen :=0;
 fCommbe:=0;
 FAutoTHR:=TRUE;

 FOnProgress:=nil;

end;

procedure TColorFrequence.ColorStatistic;
Var
    cbufPoint:PLongWord;
    W,H:WORD;

begin

 // if Assigned( FOnProgress) then   FOnProgress(10,'Grab Frame...');
 // fVideoBox.GetBitmap(fFrameBmp);
 // if Assigned( FOnProgress) then   FOnProgress(20,'Grab Frame...OK');


  cbufPoint:=@FcolorBuf[0];
  W:=fBounds.right-fBounds.left+1;
  H:=fBounds.BOTTOM-fBounds.top+1;


 if FAutoTHR then
  begin
     if Assigned( FOnProgress) then   FOnProgress(30,'gather statistics...');


     GetCOLORPALETE(fBounds.LEFT,fBounds.TOP,W,H,fFrameBmp.Handle);
     if Assigned( FOnProgress) then   FOnProgress(40,'gather statistics...OK');
     COLOBUFSMOOTHEN(cbufPoint);

     GetHistogrom;
 end
 else
 begin
   if Assigned( FOnProgress) then   FOnProgress(50,'gather statistics...');

    GetCOLORPALETE(fBounds.LEFT,fBounds.TOP,W,H,fFrameBmp.Handle);

   if Assigned( FOnProgress) then   FOnProgress(100,'gather statistics...OK');


 end;

end;

procedure TColorFrequence.DrawBW;
var
Bitmap: Windows.TBitmap;
bmpadr:PBytearray;
wadr:PWORDarray;
l,y,i,j,w,h:integer;
wo,r,g,b:WORD;
begin
  GetObject(fFrameBmp.Handle,sizeof(Bitmap),@Bitmap);
  l:=BytesPerScanline(Bitmap.bmWidth,Bitmap.bmBitsPixel,32);


  w:= fFrameBmp.Width;
  h:= fFrameBmp.Height;
  y:=0;
  for i:=0 to h-1 do
  begin
   integer(bmpadr):= integer(Bitmap.bmBits)+(y*l);


   for j:=0 to w-1 do
   begin
    integer(wadr):= integer(bmpadr);
    wo:=wadr[0];
    r := (wo and $F800) shr 11;
    g :=(wo and $07E0)  shr 6 ;
    b := wo and $001F;
    wo:=(r+g+b) div  3;
    if    wo >= THR then wadr[0]:=$FFFF
    else                 wadr[0]:=0;
    inc(integer(bmpadr),2);
   end;
   inc(y);
  end;


end;



procedure TColorFrequence.GetCOLORPALETE(left,top,W,H:integer;Graphic: HBitmap);
var
Bitmap: Windows.TBitmap;
bmpadr:PBytearray;
wadr:PWORDarray;
l,y,i,j:integer;
wo,r,g,b:WORD;
begin
  GetObject(Graphic,sizeof(Bitmap),@Bitmap);
  l:=BytesPerScanline(Bitmap.bmWidth,Bitmap.bmBitsPixel,32);


  w:=w shr 1 ;
  h:=h shr 1 ;
  y:=top;
  for i:=0 to h-1 do
  begin
   integer(bmpadr):= integer(Bitmap.bmBits)+(y*l)+(left*2);

   for j:=0 to w-1 do
   begin
    integer(wadr):= integer(bmpadr);
    wo:=wadr[0];
    r := (wo and $F800) shr 11 ;
    g :=(wo and $07E0) shr   6 ;
    b := (wo and $001F)  ;
    wo:=((r+g+b) div  3) and $1f;

    FcolorBuf[wo]:=FcolorBuf[wo]+1;
    inc(integer(bmpadr),4);
   end;
   inc(y,2);
  end;

end;




FUNCTION  FINDMINTHR(colorbuf:PLONGWORD):BYTE;
ASM

            PUSH EDI
            PUSH EBX


            MOV EDI,colorbuf
            XOR EBX,EBX
            MOV ECX,32
@FINDMINTHR1:
            MOV EAX,[EDI]
            CMP EAX,0
            JA @FINDMINTHR2
            ADD EDI,4
            INC EBX
            LOOP @FINDMINTHR1

            MOV AX,0FFFFH
            JMP @FINDMINTHR3
@FINDMINTHR2:
             MOV AX,BX
@FINDMINTHR3:



            POP EBX
            POP EDI
            RET
END;

FUNCTION  FINDMAXTHR(colorbuf:PLONGWORD;s,e:BYTE):BYTE;
ASM

            PUSH EDI
            PUSH EBX




            MOV EDI,colorbuf

            MOVZX   EBX,e
            SHL     EBX,2
            ADD     EDI,EBX

                               //DL=S
@FINDMAXTHR1:
            MOV EAX,[EDI]
            CMP EAX,0
            JA @FINDMAXTHR2
            SUB EDI,4
            DEC e
            CMP s,e
            JNE @FINDMAXTHR1

            MOV AX,0FFFFH
            JMP @FINDMAXTHR3
@FINDMAXTHR2:
             MOVZX AX,e
@FINDMAXTHR3:

            POP EBX
            POP EDI

END;












procedure TColorFrequence.setBounds(R:TRECT);
var
w,h:integer;
begin
 w:=320;
 h:=240;

 fBounds:=r;
 if fBounds.Left   <  0  then fBounds.Left:=0;
 if fBounds.Right  >= w  then fBounds.Right :=w-1;
 if fBounds.Top    <  0  then fBounds.Top   :=0;
 if fBounds.Bottom >= h  then fBounds.Bottom:=h-1;


 if Assigned( FOnProgress) then   FOnProgress(0,'Set Bounds');

end;

Function TColorFrequence.GetColorBuf(index:integer):LONGWORD;
begin

 if ( index >=0 ) AND (index< ColorBufSize) then
 begin
   Result:=FcolorBuf[index];

   if Assigned( FOnProgress) then   FOnProgress(100,'Get Gray('+Inttostr(index) +') Distribute:'+inttostr(Result));

 end
 else
   Result:=0;

end;

procedure TColorFrequence.SetMidThr(Value:BYTE);
begin
 if  (Value<=31) AND  (fMidThr<>Value) then
 begin
    fMidThr:=Value;
    if Assigned( FOnProgress) then   FOnProgress(0,'Set THR');
 end;

end;



procedure TColorFrequence.GetHistogrom;
Var
    i,j:BYTE;
    Thresholding,h:double;

begin

   if Assigned( FOnProgress) then   FOnProgress(50,'find min thr...');

   fMinThr:=FINDMINTHR(@FColorBuf[0]);
//   INC(fMinThr);
   IF  fMinThr > 31 THEN  fMinThr:=0;

   if Assigned( FOnProgress) then   FOnProgress(60,'find max thr...');

   fMaxThr:=FindMaxTHR(@FColorBuf[0],fMinThr,31);
   IF  fMaxThr > 31 THEN  fMaxThr:=31;



 fHiBen:=fMinThr;
 for i:=fMinThr to fMaxThr  do
   begin
     if FColorBuf[i] >= FColorBuf[fHiBen] then     fHiBen:=i;
   end;

   Thresholding:=FColorBuf[fHiBen]/50.0;

   h:=0;   j:=0;
   for i:=fMaxThr downto  fHiBen  do
   begin
     h:=h+FColorBuf[i];
     if h>=Thresholding then
      begin
         j:=i;
         break;
      end;
   end;


 for i:=j to fMaxThr do
  begin
   if FColorBuf[i]>FColorBuf[j] then  j:=i;
  end;
  fMaxThr:=j;

 h:=0;
 for i:=fMinThr to fHiBen do
  begin
     h:=h+FColorBuf[i];
     if h>=Thresholding then
       begin
        j:=i;  break;
       end;
  end;

 for i:=j downto fMinThr do
   begin
   if FColorBuf[i]>FColorBuf[j] then  j:=i;
   end;

 fMinThr:=j;

 if Assigned( FOnProgress) then   FOnProgress(70,'Commbe...');

 GetCommbe;

 if Assigned( FOnProgress) then   FOnProgress(80,'Find mid thr...');

 GetMidThr;

 if Assigned( FOnProgress) then   FOnProgress(100,'Get THR...OK');

end;

procedure TColorFrequence.GetCommbe;
Var
    i,j:BYTE;
    p,d:double;
begin


  fCommbe:=(fMinThr+fMaxThr) shr 1;
  j:=fCommbe;

  if (fHiBen-fMinThr)=(fMaxThr-fHiBen)  then
   begin
     if fHiBen< (ColorBufSize shr 1)    then  fMaxThr:=fHiBen
     else if fHiBen>(ColorBufSize shr 1)  then  fMinThr:=fHiBen;
     fCommbe:=(fMinThr+fMaxThr) shr 1;
     j:=fCommbe;
   end;


  if (fHiBen-fMinThr) > (fMaxThr-fHiBen)  then
    begin
      fMaxThr:=fHiBen;

      for i:=fMaxThr-1 downto fMinThr do
      begin
             if (FColorBuf[i+1]<  FColorBuf[i]   )     AND
                (FColorBuf[i+1]<= FColorBuf[fCommbe])  then
             begin
                 fCommbe:=i+1;
             end


      end;



      for i:=fCommbe downto j do
          if FColorBuf[fCommbe]<FColorBuf[i] then
            begin
             fCommbe:=i;  break;
             end;

      j:=fMinThr;
      for i:=fCommbe downto  fMinThr do
          if FColorBuf[i] > FColorBuf[j] then j:=i;


     fMinThr:=j;




     p:=FColorBuf[fMaxThr]/FColorBuf[fMinThr];
     for i:=fMinThr to (fCommbe-1) do
     begin
       d:=FColorBuf[i];
       d:=d*p;
       FColorBuf[i]:=ROUND(d);
     end;


     for i:=(fMaxThr-1) downto fMinThr do
         if (FColorBuf[i+1]< FColorBuf[i]   )    AND
            (FColorBuf[i]  < FColorBuf[i-1] )    AND
            (FColorBuf[i+1]<=FColorBuf[fCommbe])  then
            fCommbe:=i+1;

     for i:=fCommbe downto  j  do
         if FColorBuf[fCommbe]<FColorBuf[i] then
           begin
              fCommbe:=i;  break;
           end;


     for i:=fCommbe  downto 0  do
         if FColorBuf[i]>FColorBuf[fMinThr] then   fMinThr:=i;

  end
  else
  begin
    fMinThr:=fHiBen;


    for i:=(fMinThr+1) to fMaxThr  do
        if (FColorBuf[i-1]< FColorBuf[i]   )    AND
           (FColorBuf[i]  < FColorBuf[i+1] )    AND
           (FColorBuf[i-1]<=FColorBuf[fCommbe] ) then
           fCommbe:=i-1;

    for i:=fCommbe to j do
        if FColorBuf[fCommbe]<FColorBuf[i] then
           begin
             fCommbe:=i;  break;
           end;


    j:=fMaxThr;
    for i:=fCommbe to fMaxThr do
        if FColorBuf[i]>FColorBuf[j] then j:=i;

    fMaxThr:=j;

    p:=FColorBuf[fMinThr]/FColorBuf[fMaxThr];
    for i:=fMaxThr downto (fCommbe+1) do
    begin
        d:=FColorBuf[i];
        d:=d*p;
        FColorBuf[i]:=ROUND(d);
    end;

    for i:=(fMinThr+1) to fMaxThr do
        if(FColorBuf[i-1]< FColorBuf[i]   )    AND
          (FColorBuf[i]  < FColorBuf[i+1] )    AND
          (FColorBuf[i-1]<=FColorBuf[fCommbe])   then
           fCommbe:=i-1;

    for i:=fCommbe to  j  do
        if FColorBuf[fCommbe]<=FColorBuf[i] then
          begin
            fCommbe:=i;  break;
          end;

    for i:=fCommbe to (ColorBufSize-1) do
        if FColorBuf[i]>FColorBuf[fMaxThr] then fMaxThr:=i;

  end;

end;

procedure TColorFrequence.GetMidThr;
Var
  h1,h2:double;
  i,j  :BYTE;
begin

  h1:=0; h2:=0;
  for i:=fMinThr to fMaxThr do  h1:=h1+FColorBuf[i];

  h1:=h1/2;

  j:=fMinThr+1;
  while h2<h1  do
   begin
       h2:=h2+FColorBuf[j];
       if(h2>=h1)      then break;
       INC(j);
       if j >= fMaxThr then break;
   end;



  fMidThr:=j;

  if fMaxThr = fHiBen then
   begin
     i:=fMidThr;

     while i>fMinThr  do
      begin
         if FColorBuf[i] < FColorBuf[fMidThr] then fMidThr:=i;
         DEC(i);
      end;




     i:=fMidThr;
     while i<fMaxThr do
     begin
       if FColorBuf[i] <= FColorBuf[fMidThr] then fMidThr:=i;
       INC(i);
     end;





  end
  else
  begin
     i:=fMidThr;
     while i<fMaxThr do
     begin
      if FColorBuf[i] < FColorBuf[fMidThr] then   fMidThr:=i;
      INC(i);
     end;
     i:=fMidThr;




     while i>fMinThr do
      begin
       if FColorBuf[i]<=FColorBuf[fMidThr] then  fMidThr:=i;
       DEC(i);
      end;

  end;
end;





end.
