unit FindCenterProc;

//v3

interface

uses Windows,extctrls,SysUtils,classes,Dialogs,Graphics,
     Messages,Forms,CommonUnit,WaitBox,VideoCapture,CapFunction;

const
     scanLEFT  =0;
     scanTOP   =1;
     scanRIGHT =2;
     scanBOTTOM=3;
 type
    PHLINEPOINT=^HLINEPOINT;
    HLINEPOINT = record
     left:integer;
     right:integer;
     y:Integer;
    end;

    PVLINEPOINT=^VLINEPOINT;
    VLINEPOINT =record
      top:integer;
      bottom:integer;
      x:Integer;
    end;


    TFindObject=class(TProcedureObject)
     public

     IsFind :BOOLEAN;
     FindCount:integer;

     constructor Create(c:TCartonObject;autoSearch:Boolean=True);  virtual;
     destructor  Destroy; override;


     procedure GetImage;            virtual;
     procedure GetRectImage;
     function  Search:Boolean;      virtual;
     function  FindCenter:Boolean;  virtual;
     procedure AutoTHR(b:BOOLean);


     procedure  ExecuteFind;
     procedure  ExecuteFind2;

   protected
       FCenter      : TDPoint;
       FCartonObject: TCartonObject;
       FAutoSearch  :Boolean;
       FFlawCount   :Integer;
       FInterval    :TSize;
       FMidTHR      :BYTE;
       FScanColor   :BYTE;
       FCmpColor    :BYTE;


       Fext:TSize;

       FextColor:WORD;

       FColorFrequence :TColorFrequence ;

       fBmp:Windows.TBitmap;
       fBytesPerScanline:integer;





       Function SearchObject:Boolean;   virtual;
       Function Scan(arrow:BYTE;Start:TPoint;color:BYTE):SMALLINT;
       Function ArrowScan(arrow:BYTE;Start:TPoint;color:BYTE):SMALLINT; virtual;




       Function GetValue(pt:TPoint):BYTE;    overload;
       Function GetValue(x,y:Integer):BYTE;  overload;

       Function CheckValue(pt:TPoint;color:BYTE):Boolean;
       Function CheckSize:Boolean;

       Function IsCircularly1(NowPt:TPoint;var Mid:TPoint):Boolean;
       Function IsCircularly2(NowPt:TPoint;var Mid:TPoint):Boolean;

       procedure SearTH(var Pt:TPoint);
       procedure SearBH(var Pt:TPoint);
       Function  SearRV(var Pt:TPoint):TPoint;
       Function  SearLV(var Pt:TPoint):TPoint;

       Function  ScanHLine(Start:TPoint;Color:BYTE):HLINEPOINT;
       Function  ScanVLine(Start:TPoint;Color:BYTE):VLINEPOINT;
       Function  CheckNextVLine(var NextPt:TPoint;var LinePt:VLINEPOINT):Boolean;
       Function  CheckNextHLine(var NextPt:TPoint;var LinePt:HLINEPOINT):Boolean;


       Procedure GetLineCenter(Angle:Integer;LineCenter:PDPoint);
       procedure FocusLine(Angle:double;StartPt,EndPt:PDPoint);
       procedure GetLinePt(Angle:double;Pt:PDPoint;item:Integer);
       procedure ReadLien(m:double;Pt1,Pt2:PDPoint);
       function  MoncLine(StartPt,EndPt:PDPoint):double;

       function  GetBounds:TRect;
       procedure SetBounds(r:TRect);


       procedure DrawFrame(c:TPoint;r:TPoint;color:WORD);



       Function  GetBmpAddress(x,y:WORD):PBytearray;
       Function  READPIXEL(x,y:WORD):WORD;
       Function  TowValue(x,y:word):BYTE; virtual;

       FUNCTION VScan(X,Y:SMALLINT;THR,COLOR:BYTE;FLAW_COUNT:WORD;ARR:BYTE):SMALLINT;
       FUNCTION HScan(X,Y:SMALLINT;THR,COLOR:BYTE;FLAW_COUNT:WORD;ARR:BYTE):SMALLINT;


     published
       property   Center:TDPoint read  FCenter write  FCenter;
       property   Bounds:TRect read GetBounds write SetBounds;


    end;

    Function SortCompare(Item1, Item2: Pointer): Integer;
    function handleCenters(CenterList:TList):double;

//    PROCEDURE DRAWBW(A:TRECT;thr:BYTE);


implementation


procedure  TFindObject.ExecuteFind;
var
pt:TPoint;
CenterXList : TList;
CenterYList : TList;
count:integer;
centerx,centery:PDouble;
i:integer;
begin

  if  FindCount=1 then
  begin
   if assigned(OnProgressMessage) then OnProgressMessage(10,'Grab Image...');
   GetImage;
   if assigned(OnProgressMessage) then OnProgressMessage(20,'Search...');
   IsFind:=Search;

   if IsFind  then
   begin
      if assigned(OnProgressMessage) then OnProgressMessage(30,'Find Center...');


      if  FindCenter then
      begin
        pt.x:=Round(center.x);
        pt.y:=Round(center.y);
        FCartonObject.CursorPoint:=pt;
        if assigned(OnProgressMessage) then OnProgressMessage(100,'Find Center...OK');
      end
      else IsFind:=False;


   end;
  end
  else
  begin
   CenterXList := TList.Create;
   CenterYList := TList.Create;
   CenterXList.Sort(SortCompare);
   CenterYList.Sort(SortCompare);

   count:=0;
    while count<FindCount do
    begin


      INC(count);
      if assigned(OnProgressMessage) then OnProgressMessage(10,'Find Count '+inttostr(count) +':Grab Image...');
      GetImage;
      if assigned(OnProgressMessage) then OnProgressMessage(20,'Find Count '+inttostr(count) +':Search...');

      IsFind:=Search;
      if IsFind  then
      begin
        if assigned(OnProgressMessage) then OnProgressMessage(30,'Find Count '+inttostr(count) +'Find Center...');


       if  FindCenter then
       begin
        New(centerx);
        New(centery);
        centerx^:=Center.x;
        centery^:=Center.y;
        CenterXList.Add(centerx);
        CenterYList.Add(centery);
        pt.x:=Round(centerx^);
        pt.y:=Round(centery^);
        FCartonObject.CursorPoint:=pt;
   //     if count<FindCount then Bounds:= FCartonObject.CartonRect;
        if assigned(OnProgressMessage) then OnProgressMessage(40,'Find Count '+inttostr(count) +'Find Center...OK');

       end
       else
       begin
         IsFind:=False;
//         break;
       end;
      end;
    //  else break;

    end;


   if assigned(OnProgressMessage) then OnProgressMessage(50,'Gather Statistics Centers...');



    if (CenterXList.Count>0) AND (CenterYList.Count>0)  then
    begin
      if CenterXList.Count=1 then Fcenter.x:=double(CenterXList.Items[0]^)
      else  Fcenter.x:=handleCenters(CenterXList);

      if CenterYList.Count=1 then Fcenter.y:=double(CenterYList.Items[0]^)
      else  Fcenter.y:=handleCenters(CenterYList);

       if  (center.x>0) AND (center.x< VP_VideoWidth)  AND
           (center.y>0) AND (center.y< VP_VideoHeight) then
            begin
             IsFind:=TRUE;
             pt.x:=Round(center.x);
             pt.y:=Round(center.y);
             FCartonObject.CursorPoint:=pt;

              if assigned(OnProgressMessage) then OnProgressMessage(40,'Find Center:('+inttostr(pt.x) +','+inttostr(pt.y) +')...OK');



            end
       else  IsFind :=False;

    end
    else  IsFind:=False;


    while CenterXList.Count > 0 do
    begin
     i:=CenterXList.Count-1;
     centerx:=CenterXList.Items[i];
     CenterXList.Remove(centerx);
     Dispose(centerx);
    end;


    while CenterYList.Count > 0 do
    begin
     i:=CenterYList.Count-1;
     centerY:=CenterYList.Items[i];
     CenterYList.Remove(centery);
     Dispose(centerY);
    end;

    if assigned(OnProgressMessage) then OnProgressMessage(100,'Gather Statistics Centers...OK');




       CenterXList.Free;
       CenterYList.Free;
  end;

end;


procedure  TFindObject.ExecuteFind2;
var
pt:TPoint;
CenterXList : TList;
CenterYList : TList;
count:integer;
centerx,centery:PDouble;
i:integer;
begin




  if  FindCount=1 then
  begin
   if assigned(OnProgressMessage) then OnProgressMessage(10,'Grab Image...');

//    GetImage;
    GetRectImage;


   if assigned(OnProgressMessage) then OnProgressMessage(20,'Search...');

   IsFind:=Search;

     if IsFind  then
     begin
      if assigned(OnProgressMessage) then OnProgressMessage(30,'Find Center...');


       FindCenter;
       pt.x:=Round(center.x);
       pt.y:=Round(center.y);
       FCartonObject.CursorPoint:=pt;

      if assigned(OnProgressMessage) then OnProgressMessage(100,'Find Center...OK');


     end;
  end
  else
  begin
   CenterXList := TList.Create;
   CenterYList := TList.Create;
   CenterXList.Sort(SortCompare);
   CenterYList.Sort(SortCompare);

   count:=0;
    while count<FindCount do
    begin


      INC(count);

     if assigned(OnProgressMessage) then OnProgressMessage(10,'Find Count '+inttostr(count) +':Grab Image...');

      GetRectImage;

     if assigned(OnProgressMessage) then OnProgressMessage(20,'Find Count '+inttostr(count) +':Search...');


      IsFind:=Search;
      if IsFind  then
      begin
        if assigned(OnProgressMessage) then OnProgressMessage(30,'Find Count '+inttostr(count) +'Find Center...');


        New(centerx);
        New(centery);
        FindCenter;
        centerx^:=Center.x;
        centery^:=Center.y;
        CenterXList.Add(centerx);
        CenterYList.Add(centery);

        pt.x:=Round(centerx^);
        pt.y:=Round(centery^);
        FCartonObject.CursorPoint:=pt;

         if count<FindCount then Bounds:= FCartonObject.CartonRect;

        if assigned(OnProgressMessage) then OnProgressMessage(40,'Find Count '+inttostr(count) +'Find Center...OK');


      end
      else break;

    end;


   if assigned(OnProgressMessage) then OnProgressMessage(50,'Gather Statistics Centers...');



    if (CenterXList.Count>0) AND (CenterYList.Count>0)  then
    begin
      if CenterXList.Count=1 then Fcenter.x:=double(CenterXList.Items[0]^)
      else  Fcenter.x:=handleCenters(CenterXList);

      if CenterYList.Count=1 then Fcenter.y:=double(CenterYList.Items[0]^)
      else  Fcenter.y:=handleCenters(CenterYList);

       if  (center.x>0) AND (center.x< VP_VideoWidth)  AND
           (center.y>0) AND (center.y< VP_VideoHeight) then
            begin
             IsFind:=TRUE;
             pt.x:=Round(center.x);
             pt.y:=Round(center.y);
             FCartonObject.CursorPoint:=pt;
            end
       else  IsFind :=False;

    end
    else  IsFind:=False;


 while CenterXList.Count > 0 do
 begin
  i:=CenterXList.Count-1;
  centerx:=CenterXList.Items[i];
  CenterXList.Remove(centerx);
  Dispose(centerx);
 end;


 while CenterYList.Count > 0 do
 begin
  i:=CenterYList.Count-1;
  centerY:=CenterYList.Items[i];
  CenterYList.Remove(centery);
  Dispose(centerY);
 end;

 if assigned(OnProgressMessage) then OnProgressMessage(100,'Gather Statistics Centers...OK');




       CenterXList.Free;
       CenterYList.Free;
  end;

end;





constructor TFindObject.Create(c:TCartonObject;autoSearch:Boolean);
Var
r:TRect;
begin
   inherited Create;


   FCartonObject:=c;
   GetObject(FCartonObject.Bitmap.Handle,sizeof(fBmp),@fBmp);
   fBytesPerScanline:=BytesPerScanline(fBmp.bmWidth,fBmp.bmBitsPixel,32);

   TColorFrequence.Create(FCartonObject.VideoCanvas,FCartonObject.Bitmap);
   FColorFrequence.AutoThr:= FCartonObject.AutoTHR;
   FColorFrequence.THR    := FCartonObject.THR;

   if FCartonObject.Color = VP_WHITE  then
    begin
     FScanColor:= VP_WHITE;
     FCmpColor := VP_BLACK;
    end
    else
    begin
     FScanColor:=VP_BLACK;
     FCmpColor:=VP_WHITE;
    end;




   FCenter.x:=0;
   FCenter.y:=0;
   FAutoSearch:=autoSearch;
   FFlawCount:=3;

  if FAutoSearch then
  begin
      r.Left    :=0;
      r.Top     :=0;
      r.Right   :=VP_VideoWidth -1;
      r.Bottom  :=VP_VideoHeight-1;
      FColorFrequence.Bounds:=r;
  end
  else
  begin
      r:=FCartonObject.CartonRect;
      Bounds:=r;
  end;

   FInterval.cx := FCartonObject.Size.cx div 6;
   FInterval.cy := FCartonObject.Size.cy div 6;

  if FInterval.cx < 2  then FInterval.cx := 2;
  if FInterval.cy < 2  then FInterval.cy := 2;


  OnProcedureExecute:=ExecuteFind;
  IsFind:=FALSE;
  FindCount:=1;

end;

destructor TFindObject.Destroy;
begin
   FColorFrequence.free;
   FCartonObject:=nil;
   inherited Destroy;
end;

function  TFindObject.GetBounds:TRect;
begin
  result:=FColorFrequence.Bounds;
end;

procedure TFindObject.SetBounds(r:TRect);
begin
  r.left  := r.left   - 5 ;
  r.top   := r.top    - 5 ;
  r.right := r.right  + 5 ;
  r.bottom:= r.bottom + 5 ;
  FColorFrequence.Bounds:=r;

end;

procedure TFindObject.AutoTHR(b:BOOLean);
begin
  FColorFrequence.AutoThr:=b;
end;


procedure TFindObject.GetRectImage;
//var
//R:TRect;
begin
       FMidTHR:= FColorFrequence.THR;
       FCartonObject.VideoCanvas.GetBitmap(FCartonObject.Bitmap);

       //  R:= FColorFrequence.Bounds;
       //  DrawBW(R,FMidTHR);
end;


procedure TFindObject.GetImage;
//Var
//R:TRect;
begin

//    SendMessage(Application.mainForm.Handle,PWM_FindCenterMSG,fcGRABFRAME,0);

    if FColorFrequence.AutoThr  then
     begin
       FColorFrequence.OnProgress:=OnProgressMessage;

       FCartonObject.VideoCanvas.GetBitmap(FCartonObject.Bitmap);
       FColorFrequence.ColorStatistic;
       FMidTHR:= FColorFrequence.THR;
       FCartonObject.THR:=FColorFrequence.THR;
     end
    else
     begin
       FCartonObject.VideoCanvas.GetBitmap(FCartonObject.Bitmap);
       FMidTHR:= FColorFrequence.THR;
     end;
{
     if  FindCenter_Debug then
     begin
      R:= FColorFrequence.Bounds;
      DrawBW(R,FMidTHR);
     end;
}

end;


Function TFindObject.GetBmpAddress(x,y:WORD):PBytearray;
var
adr:integer;
begin

 if (x>=VP_VideoWidth) OR (y>=VP_VideoHeight) then
 begin
  adr:=0;
 end
 else
 begin
  adr:=integer(fbmp.bmBits) + integer(y*fBytesPerScanline)+ integer(x shl 1);
 end;

 integer(result):=adr;

end;


Function  TFindObject.READPIXEL(x,y:WORD):WORD;
var
bmpadr:PBytearray;
bmpadr2:PWORDarray;
begin
 bmpadr:=GetBmpAddress(x,y);

 if assigned(bmpadr) then
 begin
   integer(bmpadr2):=integer(bmpadr);
   result:=bmpadr2[0];
 end
 else
 begin
  result:=0;
 end;


end;


Function  TFindObject.TowValue(x,y:WORD):BYTE;
var
c,r,g,b:WORD;
begin

 c:=READPIXEL(x,y);
 r:=(c and $f800) shr 11 ;
 g:=(c and $07e0) shr 6  ;
 b:=(c and $001f)        ;
 c:=((r+g+b) div 3 ) and $1f;

 if c>=FMidTHR   then  result:=  VP_WHITE
 else                  result:=  VP_BLACK;


end;

{
//IN  EAX:=A
//    DL:THR
PROCEDURE DRAWBW(A:TRECT;thr:BYTE);
VAR
W:WORD;
BLANK:BYTE;

ASM

             PUSH EDI
             PUSH ESI
             PUSH EBX



             MOV ESI,A
             MOV EBX,[ESI]
             MOV EAX,[ESI+8]
             SUB EAX,EBX
             INC EAX
             MOV W,AX

             MOV EBX,[ESI+4]
             MOV ECX,[ESI+$C]
             SUB ECX,EBX
             INC ECX


             MOV   BLANK,-1
             CLD
@DRAWTOWVALUE1:
             PUSH ECX          // PUSH HEIGHT


             MOV EDI,[ESI+4]    // Y
             MOV EAX,EDI
             SHR EAX,6

             CMP AL,BLANK
             JE  @SELBLANK1

             PUSH  EDX

             MOV  BLANK,AL
             PUSH EAX
             PUSH $A
             PUSH VPDeviceHandle
             CALL VP_OUTPW

             POP  EDX

@SELBLANK1:
             AND  EDI,3FH        // nROW=Y%64
             SHL  EDI,9         // OFFSET ADDRESS =nROW*512
             MOV  EBX,[ESI]      // X
             ADD  EDI,EBX        // OFFSET ADDRESS +=X
             AND  EDI,$7FFF
             ADD  EDI,aVPMAPAddress

             MOVZX  ECX,W

@DRAWTOWVALUE2:
              MOV AL ,BYTE PTR [EDI]
              shr AL,3
              AND AL,$1F


              CMP AL,DL
              JB  @DRAWTOWVALUE3
              MOV BYTE PTR [EDI],$FF
              JMP @DRAWTOWVALUE6
@DRAWTOWVALUE3:
              MOV BYTE PTR [EDI],0
@DRAWTOWVALUE6:
            //  STOSB
              INC EDI
              LOOP @DRAWTOWVALUE2


              INC DWORD PTR [ESI+4]

              POP  ECX
              LOOP @DRAWTOWVALUE1



              POP EBX
              POP ESI
              POP EDI


END;

}







function TFindObject.Search:Boolean;
begin
//    SendMessage(Application.mainForm.Handle,PWM_FindCenterMSG,fcSEARCH,0);
    Result:=SearchObject;
end;
{
procedure TFindObject.ShowError(s:string);
begin
  ShowMessage(s);
end;
}


Function TFindObject.SearchObject:Boolean;
Var
   FindFlag:Boolean;
   MidPt:TPoint;
   ScanPt:TPoint;
   r:TRect;
   p:byte;
begin
   FindFlag:=FALSE;

   r:=FCartonObject.CartonRect;
   r.Left   :=  r.Left    +  FInterval.cx  ;
   r.Top    :=  r.Top     +  FInterval.cy  ;
   r.Right  :=  r.Right   -  FInterval.cx  ;
   r.Bottom :=  r.Bottom  -  FInterval.cy  ;

   IF R.TOP < 0      THEN R.TOP:=0;
   IF R.BOTTOM >= 240 THEN R.BOTTOM:=239;
   IF R.LEFT  < 0    THEN R.LEFT:=0;
   IF R.RIGHT >= 320  THEN R.RIGHT:=319;





    while TRUE do
     begin
        ScanPt.x:=r.left;
        while  ScanPt.x<=r.right do
        begin
          ScanPt.y:=r.top;

 //         if ScanPt.x>512 then  ShowError('error');

          if Scan(scanBOTTOM,ScanPt,FScanColor) <   FColorFrequence.Bounds.bottom then
          begin

            while  ScanPt.y<=r.bottom do
            begin

                p:= GetValue(ScanPt);
                if p = FScanColor then
                 begin
                   if IsCircularly1(ScanPt,MidPt) then
                    begin
                       FindFlag:=TRUE;  break;
                    end
                   else
                    begin
   //                  if ScanPt.x>512 then  ShowError('error');

                     ScanPt.y:=MidPt.y;
                     ScanPt.y:=Scan(scanBOTTOM,ScanPt,FCmpColor);
                    end;

                 end
                else
                 begin
  //                if ScanPt.x>512 then  ShowError('error');
                  ScanPt.y:=Scan(scanBOTTOM,ScanPt,FCmpColor);
                 end;

                ScanPt.y:=ScanPt.y+FInterval.cy;
            end;
          end;

            if FindFlag  then
             begin
               FCenter.x := MidPt.x;
               FCenter.y := MidPt.y;
               FindFlag:=CheckSize;
               if FindFlag then break;

             end;


            ScanPt.x:=ScanPt.x+FInterval.cx;
        end;

        if FindFlag=FALSE then
        begin
           ScanPt.x:=r.right-1;
           while ScanPt.x>=R.left do
           begin
             ScanPt.y:=r.top;
    //         if ScanPt.x>512 then  ShowError('error');

             if Scan(scanBOTTOM,ScanPt,FScanColor)< FColorFrequence.Bounds.bottom then
             begin
                while ScanPt.y<=R.bottom  do
                begin

                   if GetValue(ScanPt)=FSCanColor then
                    begin
                      if IsCircularly2(ScanPt,MidPt) then
                       begin
                        FindFlag:=TRUE; break;
                       end
                      else
                       begin
        //                if ScanPt.x>512 then  ShowError('error');
                        ScanPt.y:=MidPt.y;
                        ScanPt.y:=Scan(scanBOTTOM,ScanPt,FCmpColor);
                       end;
                   end
                   else
                   begin
      //              if ScanPt.x>512 then  ShowError('error');
                    ScanPt.y:=Scan(scanBOTTOM,ScanPt,FCmpColor);
                   end;

                 ScanPt.y:= ScanPt.y+FInterval.cy;
               end;
             end;
               if FindFlag then
               begin
                  FCenter.x := MidPt.x;
                  FCenter.y := MidPt.y;
                  FindFlag:=CheckSize;
                  if FindFlag then break;
               end;
           ScanPt.x:=ScanPt.x-FInterval.cx;
           end;
        end;

        if FindFlag then  break
        else
         begin
                if (R.left  =  FColorFrequence.Bounds.left  ) AND
                   (R.top   =  FColorFrequence.Bounds.top   ) AND
                   (R.right =  FColorFrequence.Bounds.right ) AND
                   (R.bottom=  FColorFrequence.Bounds.bottom)
                 then
                 begin
                  break;
                 end
                else
                 begin

                  R.Left  :=R.left  -FCartonObject.Size.cx;
                  R.Right :=R.Right +FCartonObject.Size.cx;
                  R.Top   :=R.Top   -FCartonObject.Size.cy;
                  R.Bottom:=R.Bottom+FCartonObject.Size.cy;

                  if R.right  > FColorFrequence.Bounds.right  then R.right  := FColorFrequence.Bounds.right ;
                  if R.left   < FColorFrequence.Bounds.left   then R.left   := FColorFrequence.Bounds.left  ;
                  if R.bottom > FColorFrequence.Bounds.bottom then R.bottom := FColorFrequence.Bounds.bottom;
                  if R.top    < FColorFrequence.Bounds.top    then R.top    := FColorFrequence.Bounds.top   ;
                 end;

        end;
    end;

  if (MidPt.x >=  FColorFrequence.Bounds.right ) OR
     (MidPt.x <=  FColorFrequence.Bounds.left  ) OR
     (MidPt.y >=  FColorFrequence.Bounds.bottom) OR
     (MidPt.y <=  FColorFrequence.Bounds.top   ) then
     FindFlag:=FALSE;



   Result:=FindFlag;
end;







FUNCTION TFindObject.VScan(X,Y:SMALLINT;THR,COLOR:BYTE;FLAW_COUNT:WORD;ARR:BYTE):SMALLINT;
var
fc:Integer;
k:BYTE;
c,r,g,b:WORD;
bmpadr:PBYTEARRAY;
bmpadr2:PWORDArray;
begin

 if (x >=VP_VideoWidth  ) OR
    (x <0               ) OR
    (y >= VP_VideoHeight) OR
    (y < 0              ) then
   begin
   // ShowError('TopScan='+Inttostr(Start.x)+','+inttostr(Start.y));
    Result:=0;
    exit;
   end;


  fc:=0;
  while TRUE do
  begin
     bmpadr:=GetBmpAddress(x,y);
     if assigned(bmpadr)=FALSE then break;

     integer(bmpadr2):=integer(bmpadr);
     c:=bmpadr2[0];
     r:=(c and $f800) shr 11 ;
     g:=(c and $07e0) shr 6  ;
     b:=(c and $001f)        ;
     c:=((r+g+b) div 3) and $1f;
     k:=c;

     if k< FMidTHR then k:=0
     else               k:=$1f;

     if k = color  then  fc:=0
     else
     begin
       INC(fc);
       if fc> FFlawCount then
        begin
          break;
        end;
     end;



     if arr=1 then
     begin
      if y>=(VP_VideoHeight-1) then  break
      else                           inc(y);
     end
     else
     begin
       if y<=0                 then  break
       else                          dec(y);
     end;

  end;



  if arr=1 then   y:=y-fc
  else            y:=y+fc;

  if y>=VP_VideoHeight then y:=VP_VideoHeight-1;
  if y<0              then  y:=0;

  Result:=y;

end;


FUNCTION TFindObject.HScan(X,Y:SMALLINT;THR,COLOR:BYTE;FLAW_COUNT:WORD;ARR:BYTE):SMALLINT;
var
fc:Integer;
k:BYTE;
c,r,g,b:WORD;
bmpadr:PBYTEARRAY;
bmpadr2:PWORDArray;
begin
  if (x >=VP_VideoWidth  ) OR
    (x <0               ) OR
    (y >= VP_VideoHeight) OR
    (y <0              ) then
   begin
   // ShowError('TopScan='+Inttostr(Start.x)+','+inttostr(Start.y));
    Result:=0;
    exit;
   end;


   bmpadr:=GetBmpAddress(0,y);
   if assigned(bmpadr)=FALSE then
   begin
    Result:=0;
    exit;
   end;

  integer(bmpadr2):=integer(bmpadr);
  fc:=0;
  while TRUE do
  begin
     c:=bmpadr2[x];
     r:=(c and $f800) shr 11 ;
     g:=(c and $07e0) shr 6  ;
     b:=(c and $001f)        ;
     c:=((r+g+b) div 3) and $1f;
     k:=c;

     if k< FMidTHR then k:=0
     else               k:=$1f;

     if k = color  then  fc:=0
     else
     begin
       INC(fc);
       if fc> FFlawCount then
        begin
          break;
        end;
     end;



     if arr=1 then
     begin
      if x>=(VP_VideoWidth-1) then  break
      else                          inc(x);
     end
     else
     begin
       if x<=0                 then  break
       else                          dec(x);
     end;

  end;



  if arr=1 then   x:=x-fc
  else            x:=x+fc;

  if x>=VP_VideoWidth then x:=VP_VideoWidth-1;
  if x<0              then x:=0;

  Result:=x;



end;



Function  TFindObject.ArrowScan(arrow:BYTE;Start:TPoint;color:BYTE):SMALLINT;
begin
//   X,Y:WORD;THR,SCANCOLOR:BYTE;FLAW_COUNT:WORD

   RESULT:=0;
   case  arrow of
   scanLEFT:   RESULT:=HScan(Start.X,Start.Y,FMidThr,color,FFlawCount,0);
   scanRIGHT:  RESULT:=HScan(Start.X,Start.Y,FMidThr,color,FFlawCount,1);
   scanTOP:    RESULT:=VScan(Start.X,Start.Y,FMidThr,color,FFlawCount,0);
   scanBOTTOM: RESULT:=VScan(Start.X,Start.Y,FMidThr,color,FFlawCount,1);
   end;
end;


Function  TFindObject.Scan(arrow:BYTE;Start:TPoint;color:BYTE):SMALLINT;
Var
   p:Integer;
begin
 p := ArrowScan(arrow,Start,color);

 case  arrow of
   scanLEFT:

                if p>Start.x  then             p:=Start.x
                else if p< Bounds.left   then  p:=Bounds.left;

   scanRIGHT:
                if p<Start.x  then           p:=Start.x
                else if p>Bounds.right then  p:=Bounds.right;

   scanTOP:
                if p>Start.y then             p:=Start.y
                else if p<Bounds.top    then  p:=Bounds.top;

   scanBOTTOM:
                if p<Start.y then             p:=Start.y
                else if p>Bounds.bottom then  p:=Bounds.bottom;
 end;


 Result:=p;

end;





Function  TFindObject.GetValue(pt:TPoint):BYTE;
begin
  result:=GetValue(pt.x,pt.y);
end;


Function  TFindObject.GetValue(x,y:Integer):BYTE;
begin

  if (x<0 ) OR (x>= VP_VideoWidth)  OR
     (y<0 ) OR (y>= VP_VideoHeight) then
  begin
     Result:=1;
     exit;
  end;
  Result:=TowValue(X,Y);
end;

Function TFindObject.CheckValue(pt:TPoint;color:BYTE):Boolean;
Var
   R:TRect;
   i:Integer;
begin

 i:=0;
 R.left  :=Pt.x-1;
 R.right :=Pt.x+1;
 R.top   :=Pt.y-1;
 R.bottom:=Pt.y+1;


 if GetValue(R.TopLeft )     = color then INC(i);
 if GetValue(R.Right,R.Top)  = color then INC(i);
 if GetValue(R.Left,R.Bottom)= color then INC(i);
 if GetValue(R.BottomRight)  = color then INC(i);
 if GetValue(pt.x,R.top)     = color then INC(i);
 if GetValue(pt.x,R.bottom)  = color then INC(i);
 if GetValue(R.left,pt.y)    = color then INC(i);
 if GetValue(R.right,pt.y)   = color then INC(i);

 if i>=4 then Result:=TRUE
 else         Result:=FALSE;

end;


Function  TFindObject.CheckSize:Boolean;
Var
    Angle,w,h:double;
    CursorPt:TPoint;
    Pt:array[0..9] of TPoint;
    k1,k2,j,i:Integer;
    c1,c2:Integer;
begin

  if assigned(OnProgressMessage) then OnProgressMessage(35,'Check Size...');



//  SendMessage(Application.mainForm.Handle,PWM_FindCenterMSG,fcCHECKSIZE,0);

  Result:=FALSE;

  k1:=0;
  k2:=0;


  c1:=FCartonObject.Size.cx shr 2;
  c2:=FCartonObject.Size.cy shr 2;

  CursorPt.x:=Round(FCenter.x);
  CursorPt.y:=Round(FCenter.y);


  Pt[0].x:=CursorPt.x-FCartonObject.Size.cx;
  Pt[0].y:=CursorPt.y;

  if Pt[0].x<0 then Pt[0].x:=0;


  Pt[1].x:=CursorPt.x+FCartonObject.Size.cx;
  Pt[1].y:=CursorPt.y;

  if Pt[1].x>319 then Pt[1].x:=319;



  Pt[2].x:= CursorPt.x;
  Pt[2].y:= CursorPt.y-FCartonObject.Size.cy;

  if Pt[2].y<0 then Pt[2].y:=0;


  Pt[3].x:= CursorPt.x;
  Pt[3].y:= CursorPt.y+FCartonObject.Size.cy;

  if Pt[3].x>239 then Pt[3].y:=239;





  if CheckValue(Pt[0],FScanColor) then Pt[0].x:=Scan(scanLEFT ,Pt[0],FScanColor)
  else                                 Pt[0].x:=Scan(scanRIGHT,Pt[0],FCmpColor);

  if ((CursorPt.x-Pt[0].x)<=(FCartonObject.Size.cx+c1)) AND
     ((CursorPt.x-Pt[0].x)>=(FCartonObject.Size.cx-c1)) then
     INC(k1)
  else
  begin
    Pt[0].x:=-1;
    Pt[0].y:=-1;
  end;


  if CheckValue(Pt[1],FscanColor) then  Pt[1].x:=Scan(scanRIGHT,Pt[1],FScanColor)
  else                                  Pt[1].x:=Scan(scanLEFT ,Pt[1],FCmpColor);

  if ((Pt[1].x-CursorPt.x)<=(FCartonObject.Size.cx+c1))   AND
     ((Pt[1].x-CursorPt.x)>=(FCartonObject.Size.cx-c1))   then
     INC(k1)
  else
  begin
   Pt[1].x:=-1;
   Pt[1].y:=-1;
  end;


  if CheckValue(Pt[2],FscanColor) then Pt[2].y:=Scan(scanTOP   ,Pt[2],FScanColor)
  else                                 Pt[2].y:=Scan(scanBOTTOM,Pt[2],FCmpColor);

  if ((CursorPt.y-Pt[2].y)<=(FCartonObject.Size.cy+c2))  AND
     ((CursorPt.y-Pt[2].y)>=(FCartonObject.Size.cy-c2))  then
     INC(k1)
  else
  begin
   Pt[2].x:=-1;
   Pt[2].y:=-1;
  end;


  if CheckValue(Pt[3],FscanColor) then Pt[3].y:=Scan(scanBOTTOM,Pt[3],FscanColor)
  else                                 Pt[3].y:=Scan(scanTOP   ,Pt[3],FCmpColor);

  if ((Pt[3].y-CursorPt.y)<=(FCartonObject.Size.cy+c2))  AND
     ((Pt[3].y-CursorPt.y)>=(FCartonObject.Size.cy-c2)) then
     INC(k1)
  else
  begin
   Pt[3].x:=-1;
   Pt[3].y:=-1;
  end;

  i:=45; j:=4;    w:=FCartonObject.Size.cx; h:=FCartonObject.Size.cy;
  while i<360  do
   begin
      Angle:=i;
      Angle:=Angle / 57.29578;
      Pt[8].x:=Round(cos(Angle)* w)+CursorPt.x;
      Pt[8].y:=Round(sin(Angle)* h)+CursorPt.y;

      if (Pt[8].x > 319) OR (Pt[8].y>239)  then
      begin
         Pt[j].x:=-1;
      end
      else if (i=45) OR (i=315) then
       begin
         if CheckValue(Pt[8],FscanColor)  then
         Pt[j].x:=Scan(scanRIGHT,Pt[8],FscanColor)
         else
         Pt[j].x:=Scan(scanLEFT ,Pt[8],FCmpColor);
       end
      else
       begin
         if CheckValue(Pt[8],FscanColor) then
         Pt[j].x:=Scan(scanLEFT ,Pt[8],FscanColor)
         else
         Pt[j].x:=Scan(scanRIGHT,Pt[8],FCmpColor);
       end;

      if ((Pt[j].x-CursorPt.x)<=FCartonObject.Size.cx) AND
         ((Pt[j].x-CursorPt.x)>=c1)                    then
         INC(k2)
      else Pt[j].x:=-1;

      if (Pt[8].x > 319) OR (Pt[8].y>239)  then
      begin
         Pt[j].y:=-1;
      end
      else if (i=45) OR (i=135)  then
      begin
        if CheckValue(Pt[8],FscanColor) then
         Pt[j].y:=Scan(scanBOTTOM,Pt[8],FscanColor)
        else
         Pt[j].y:=Scan(scanTOP,Pt[8],FCmpColor);
      end
      else
      begin
        if CheckValue(Pt[8],FscanColor)  then
         Pt[j].y:=Scan(scanTOP,Pt[8],FscanColor)
        else
         Pt[j].y:=Scan(scanBOTTOM,Pt[8],FCmpColor);
      end;

      if ((Pt[j].y-CursorPt.y)<=FCartonObject.Size.cy) AND
         ((Pt[j].y-CursorPt.y)>=c2)                   then
         INC(k2)
      else  Pt[j].y:=-1;


      i:=i+90;
      INC(j);
  end;

  k1:=k1+k2;
  if k1>=6  then
   begin
       if CheckValue(CursorPt,FScanColor)   then
       begin


//            Pt[0].x:=Scan(scanRIGHT ,CursorPt,FScanColor);
//            Pt[1].x:=Scan(scanLEFT  ,CursorPt,FScanColor);
//            Pt[0].y:=Scan(scanTOP   ,CursorPt,FScanColor);
//            Pt[1].y:=Scan(scanBOTTOM,CursorPt,FScanColor);
//            CursorPt.x:=(Pt[0].x+Pt[1].x) shr 1;
//            CursorPt.y:=(Pt[0].y+Pt[1].y) shr 1;


         FCenter.x:=CursorPt.x;
         FCenter.y:=CursorPt.y;
         Result:=TRUE;
       end;
   end;

end;

Function TFindObject.IsCircularly1(NowPt:TPoint;var Mid:TPoint):Boolean;
Var
   f:Boolean;
   TmpX:Integer;
   Pt:TPoint;
begin
   if (NowPt.x > 319) OR
      (NowPt.x < 0)   OR
      (NowPt.y > 239) OR
      (NowPt.y < 0)
   then
   begin
    ShowMessage('ic1='+Inttostr(NowPt.x)+','+inttostr(NowPt.y));
    Result:=FALSE;
    exit;
   end;

   f:=FALSE;
   Pt:=SearLV(NowPt);

   if (Pt.y>0)    AND
      (pt.y<=239) AND
      (Pt.x>0)    AND
      (pt.x<=319)
   then
    begin
      Tmpx:=Pt.x;
      SearTH(Pt);
      if Pt.x>0 then f:=TRUE
      else
      begin
         Pt.x:=Tmpx;
         SearBH(Pt);
         if Pt.x>0 then f:=TRUE;
      end;

    end;

   if f then  Mid:=Pt
   else       Mid:=NowPt;


   if Mid.x > 319 then  Mid.x:=319;
   if Mid.x < 0   then  Mid.x:=0;
   if Mid.y > 239 then  Mid.y:=239;
   if Mid.y < 0   then  Mid.y:=0;

  result:=f;
end;

Function TFindObject.IsCircularly2(NowPt:TPoint;var Mid:TPoint):Boolean;
Var
 f:Boolean;
 TmpX:Integer;
  Pt:TPoint;

begin


   if (NowPt.x > 319) OR
      (NowPt.x < 0)   OR
      (NowPt.y > 239) OR
      (NowPt.y < 0)
   then
   begin
    ShowMessage('Scan 2='+Inttostr(NowPt.x)+','+inttostr(NowPt.y));
    Result:=FALSE;
    exit;
   end;


  f:=FALSE;
  Pt:=SearRV(NowPt);
  if (Pt.y>0)    AND
     (pt.y<=239) AND
     (Pt.x>0)    AND
     (pt.x<=319)
  then
  begin
     Tmpx:=Pt.x;
     SearBH(Pt);
     if Pt.x>0 then  f:=TRUE
     else
     begin
       Pt.x:=Tmpx;
       SearTH(Pt);
       if Pt.x>0 then  f:=TRUE;
     end;
  end;

   if f=TRUE then  Mid:=Pt
   else          Mid:=NowPt;


   if Mid.x > 319 then  Mid.x:=319;
   if Mid.x < 0   then  Mid.x:=0;
   if Mid.y > 239 then  Mid.y:=239;
   if Mid.y < 0   then  Mid.y:=0;

   result:=f;
end;

procedure TFindObject.SearTH(var Pt:TPoint);
Var
   i:integer;
   SizeX :Integer;
   county:Integer;
   CheckCount:Integer;
   NextPt:TPoint;
   line1:HLINEPOINT;
begin

  if (pt.x >=320) OR
     (pt.x <0   ) OR
     (pt.y>=240)  OR
     (pt.y<0)
  then
  begin
   // ShowError('TH='+Inttostr(pt.x)+','+inttostr(pt.y));
    exit;
  end;




 SizeX :=(FCartonObject.Size.cx shl 1 )+20 ;

 county:=(FInterval.cy shr 1);
 if county <=0  then  county:=1;

 CheckCount:=0;
 NextPt.x:=Pt.x;
 NextPt.y:=Pt.y;



 NextPt.y:=Scan(scanTOP,Pt,FCartonObject.Color);

 line1:=ScanHLine(NextPt,FCartonObject.Color);
 NextPt.x:=(line1.left+line1.right) div 2;
 NextPt.y:=Scan(scanTOP,NextPt,FCartonObject.Color);
 line1:=ScanHLine(NextPt,FCartonObject.Color);

 if (line1.right-line1.left) >= SizeX then
 begin
   Pt.x:=-1;   exit;
 end;

 i:=NextPt.y+county;
 while i<= FColorFrequence.Bounds.bottom do
 begin
     NextPt.y:=i;
     if CheckNextHLine(NextPt,line1) then
      begin
        INC(CheckCount);
        if CheckCount>=3 then break;
      end
     else
      begin
          NextPt.x:=-1;
          break;
      end;

     i:=i+county;
 end;

 Pt.x:=NextPt.x;

end;
procedure TFindObject.SearBH(var Pt:TPoint);
Var
   i:Integer;
   SizeX :Integer;
   county:Integer;
   CheckCount:Integer;
   NextPt:TPoint;
   line1:HLINEPOINT;
begin


   if (pt.x >=320) OR
     (pt.x <0   ) OR
     (pt.y>=240)   OR
     (pt.y<0)  then
  begin
  //  ShowError('BH='+Inttostr(pt.x)+','+inttostr(pt.y));
    exit;
  end;


  SizeX:=(FCartonObject.Size.cx shl 1)+20;

  county:=FInterval.cy shr 1;
  if county<=0 then  county:=1;

  CheckCount:=0;
  NextPt.x:=Pt.x;
  NextPt.y:=Pt.y;

  NextPt.y:=Scan(scanBOTTOM,Pt,FCartonObject.Color);
  line1:=ScanHLine(NextPt,FCartonObject.Color);

  NextPt.x:=(line1.left+line1.right) shr 1;
  NextPt.y:=Scan(scanBOTTOM,NextPt,FCartonObject.Color);
  line1:=ScanHLine(NextPt,FCartonObject.Color);

  if (line1.right-line1.left)>=SizeX then
   begin
     Pt.x:=-1;
     exit;
   end;

  i:=NextPt.y-county;
  while i>= FColorFrequence.Bounds.top do
   begin
      NextPt.y:=i;
      if CheckNextHLine(NextPt,line1) then
      begin
         INC(CheckCount);
         if CheckCount>=3 then break;
      end
      else
      begin
           NextPt.x:=-1;
           break;
      end;

     i:=i-county;
  end;

  Pt.x:=NextPt.x;


end;

Function  TFindObject.SearLV(var Pt:TPoint):TPoint;
Var
   i:Integer;
   SizeY:Integer;
   countx:Integer;
   CheckCount:Integer;
   NextPt:TPoint;
   line1:VLINEPOINT;
begin

  if (pt.x >=320) OR
     (pt.x <0   ) OR
     (pt.y>240)   OR
     (pt.y<0)then
  begin
  //  ShowError('LV='+Inttostr(pt.x)+','+inttostr(pt.y));
    exit;
  end;




 SizeY:=(FCartonObject.Size.cy shl 1)+20;
 countx:=FInterval.cx shr 1;
 if countx <=0 then  countx:=1;
 CheckCount:=0;

 line1:=ScanVLine(Pt,FCartonObject.Color);
 if (line1.bottom-line1.top)>=SizeY then
  begin
   Pt.y := FColorFrequence.Bounds.bottom;
   NextPt.y:=-1;
   Result:=NextPt;
   exit;
  end;

 IF line1.bottom > 239 THEN line1.bottom:=239  ;
 IF line1.bottom < 0   THEN line1.bottom:=0    ;

 IF line1.TOP > 239 THEN line1.TOP:=239  ;
 IF line1.TOP < 0   THEN line1.TOP:=0    ;



 Pt.y :=line1.bottom+1;
 if Pt.y>239 then pt.y:=239;
 if Pt.y<0 then   pt.y:=0;

 NextPt.y:=(line1.top+line1.bottom) shr 1;

 i:=Pt.x+countx;
  while  i<= FColorFrequence.Bounds.right do
  begin
     NextPt.x:=i;
     if CheckNextVLine(NextPt,line1) then
     begin
        INC(CheckCount);
        if CheckCount>=3 then break;
     end
     else if(CheckCount<1) then
     begin
          NextPt.y:=-1;
          break;
     end;

     i:=i+countx;
  end;


 Result:=NextPt;

end;
Function  TFindObject.SearRV(var Pt:TPoint):TPoint;
Var
   i:Integer;
   SizeY:Integer;
   countx:Integer;
   CheckCount:Integer;
   NextPt:TPoint;
   line1:VLINEPOINT;
begin

   if (pt.x >=320) OR
     (pt.x <0   ) OR
     (pt.y>=240)   OR
     (pt.y<0) then
  begin
  //  ShowError('RV='+Inttostr(pt.x)+','+inttostr(pt.y));
    exit;
  end;



  SizeY:=(FCartonObject.Size.cy shl 1)+20;
  countx:=FInterval.cx shr 1;
  if countx <=0 then countx:=1;


  CheckCount:=0;


  line1:=ScanVLine(Pt,FCartonObject.Color);

  if (line1.bottom-line1.top)>=SizeY then
   begin
    Pt.y := FColorFrequence.Bounds.bottom;
    NextPt.y:=-1;
    Result:=NextPt;
    exit;
  end
  else
  begin
  Pt.y:=line1.bottom+1;
  if Pt.y>239 then pt.y:=239;

  NextPt.y:=(line1.top+line1.bottom) shr 1;

  i:=Pt.x-countx;
  while i>= FColorFrequence.Bounds.left do
   begin
      NextPt.x:=i;
      if CheckNextVLine(NextPt,line1) then
      begin
         INC(CheckCount);
         if CheckCount>=3 then break;
      end
      else  if(CheckCount<1) then
      begin
           NextPt.y:=-1;
           break;
      end;
      i:=i-countx;
  end;

  Result:=NextPt;
 end;

end;

Function  TFindObject.ScanHLine(Start:TPoint;Color:BYTE):HLINEPOINT;
begin

 Result.left := Scan(scanLEFT ,Start,color);
 Result.right:= Scan(scanRIGHT,Start,color);
 Result.y    := Start.y;
end;

Function  TFindObject.CheckNextHLine(var NextPt:TPoint;var linePt:HLINEPOINT):Boolean;
Var
   CurrentMid  : Integer;
   CurrentLeng : Integer;
   NextLeng    : Integer;
   NextMid     : Integer;
   NextLine    : HLINEPOINT;
begin

  CurrentMid :=(LinePt.left+LinePt.right) shr 1;
  CurrentLeng:=LinePt.right-LinePt.left;

 NextLine:=ScanHLine(NextPt,FCartonObject.Color);
 NextLeng:=NextLine.right-NextLine.left;
 NextMid:=(NextLine.left+NextLine.right) shr 1;

 if(NextLeng>CurrentLeng)       AND
   (NextMid<=CurrentMid+5)      AND
   (NextMid>=CurrentMid-5)      AND
   (NextLine.left <LinePt.left) AND
   (NextLine.right>LinePt.right ) then
  begin
    LinePt.left :=NextLine.left;
    LinePt.right:=NextLine.right;
    NextPt.x:=NextMid;
    Result:=TRUE;
 end
 else  Result:=FALSE;



end;

Function  TFindObject.ScanVLine(Start:TPoint;color:BYTE):VLINEPOINT;
begin
 Result.top   := Scan(scanTOP   ,Start,color);
 Result.bottom:= Scan(scanBOTTOM,Start,color);
 Result.x     := Start.x;
end;

Function  TFindObject.CheckNextVLine(var NextPt:TPoint;var LinePt:VLINEPOINT):Boolean;
Var
     CurrentMid:Integer;
     CurrentLeng:Integer;
     NextLeng:Integer;
     NextMid:Integer;
     NextLine:VLINEPOINT;
begin

 CurrentMid :=(LinePt.top+LinePt.bottom) shr 1;
 CurrentLeng:=LinePt.bottom-LinePt.top;

 NextLine:=ScanVLine(NextPt,FCartonObject.Color);
 NextLeng:=NextLine.bottom-NextLine.top;
 NextMid:=(NextLine.top+NextLine.bottom) shr 1;

 if (NextLeng>CurrentLeng)          AND
    (NextMid<=CurrentMid+5)         AND
    (NextMid>=CurrentMid-5)         AND
    (NextLine.top   <LinePt.top)   AND
    (NextLine.bottom>LinePt.bottom )  then
  begin

    LinePt.top   :=NextLine.top;
    LinePt.bottom:=NextLine.bottom;
    NextPt.y:=NextMid;
    Result:=TRUE;
 end
 else Result:=FALSE;

end;


Function SortCompare(Item1, Item2: Pointer): Integer;
Var i1,i2:double;
begin
    i1:=PDouble(Item1)^;
    i2:=PDouble(Item2)^;
    if i1=i2      then  result:=0
    else if i1<i2 then  result:=1
    else                result:=-1;
end;





procedure TFindObject.DrawFrame(c:TPoint;r:TPoint;color:WORD);
var
red,g,b:WORD;
y:integer;
begin

 with FCartonObject.Bitmap do
 begin
  Canvas.Brush.Style:=bsClear;
  Canvas.Pen.Style:=psSolid;
  if (color and $f800) = $f800 then  red:=$FF
  else                               red:=0  ;
  if (color and $07e0) = $07e0 then  g:=$FF
  else                               g:=0    ;
  if (color and $001f) = $001f then  b:=$FF
  else                               b:=0    ;

  y:=239-c.Y;
  Canvas.Pen.Color:=RGB(Red,G,B);
  Canvas.Ellipse(c.X-r.X,Y-r.Y,c.X+r.X,Y+r.Y);
 end;


end;







function TFindObject.FindCenter:Boolean;
Var
  centerx,centery:^Double;
  i:Integer;
  LineCenter:TDPoint;
  saveBounds:TRect;
  Cursor:TPoint;
  CenterXList:TList;
  CenterYList:TList;

begin






  CenterXList := TList.Create;
  CenterYList := TList.Create;
  CenterXList.Sort(SortCompare);
  CenterYList.Sort(SortCompare);


  saveBounds:= FColorFrequence.Bounds;
  Cursor.x:=Round(FCenter.x);
  Cursor.y:=Round(FCenter.y);



  Fext.cx:=FCartonObject.Size.cx+2;
  Fext.cy:=FCartonObject.Size.cy+2;

  if FscanColor=0 then
  begin
     FextColor:=$F800;
  end
  else
  begin
    FextColor:=$001f;
  end;



  DrawFrame(Cursor,TPoint(Fext),FextColor);

  FColorFrequence.Bounds:=Rect(Cursor.x-Fext.cx,Cursor.y-Fext.cy,Cursor.x+Fext.cx,Cursor.y+Fext.cy);


  i:=0;
  while i<10 do
  begin
      GetLineCenter(i*8,@LineCenter);
      if ((LineCenter.x>=0) AND (LineCenter.x< VP_VideoWidth))   AND
         ((LineCenter.y>=0) AND (LineCenter.y< VP_VideoHeight))
         then
      begin
         New(centerx);
         New(centery);
         centerx^:=LineCenter.x;
         centery^:=LineCenter.y;
         CenterXList.Add(centerx);
         CenterYList.Add(centery);
      end;

      INC(i);
 end;



  FColorFrequence.Bounds:=saveBounds;

 if CenterXList.Count>0  then
    LineCenter.x:=handleCenters(CenterXList);
 if CenterYList.Count>0  then
    LineCenter.y:=handleCenters(CenterYList);

 if CenterXList.Count>0 then
     FCenter.x:=LineCenter.x;
 if CenterYList.Count>0 then
     FCenter.y:=LineCenter.y;



  if (CenterXList.Count<=0) OR (CenterYList.Count<=0) then Result:=FALSE
  else                                                     Result:=TRUE;


 while CenterXList.Count > 0 do
 begin
  i:=CenterXList.Count-1;
  centerx:=CenterXList.Items[i];
  CenterXList.Remove(centerx);
  Dispose(centerx);
 end;


 while CenterYList.Count > 0 do
 begin
  i:=CenterYList.Count-1;
  centerY:=CenterYList.Items[i];
  CenterYList.Remove(centery);
  Dispose(centerY);
 end;

  CenterXList.Free;
  CenterYList.Free;




end;

Procedure TFindObject.GetLineCenter(Angle:Integer;LineCenter:PDPoint);
var
  StartPt1,EndPt1,StartPt2,EndPt2:TDPoint;
  m1,m2,x,y:double;

begin

  FocusLine(Angle,@StartPt1,@EndPt1);
  FocusLine(90.0+Angle,@StartPt2,@EndPt2);



  if((StartPt1.x <> -1) AND (EndPt1.x <> -1) )   AND
    ((StartPt2.x <> -1) AND (EndPt2.x <> -1) )   then
  begin

     m1:= MoncLine(@StartPt1,@EndPt1);
     m2:= MoncLine(@StartPt2,@EndPt2);

     x :=m1*StartPt1.x;
     x :=x-StartPt1.y;
     x :=x-(m2*StartPt2.x);
     x :=x+StartPt2.y;
     x :=x/(m1-m2) ;
     y :=StartPt2.y-(m2*(StartPt2.x-x));

     LineCenter^.x :=x ;
     LineCenter^.y :=y ;

  end
  else
  begin
     LineCenter^.x:=-1;
     LineCenter^.y:=-1;
  end;

    if LineCenter^.x > FColorFrequence.Bounds.right   THEN LineCenter^.x:=-1;
    if LineCenter^.x < FColorFrequence.Bounds.left    THEN LineCenter^.x:=-1;
    if LineCenter^.y > FColorFrequence.Bounds.bottom  THEN LineCenter^.y:=-1;
    if LineCenter^.y < FColorFrequence.Bounds.top     THEN LineCenter^.y:=-1;

end;

procedure TFindObject.FocusLine(Angle:double;StartPt,EndPt:PDPoint);
Var
   Angle1,Angle2:double;
   l:Integer;
begin
 Angle1:=Angle;
 Angle2:=180.0+Angle;

 if FCartonObject.Size.cx >= 70 then l:=4
 else                                l:=3;

 GetLinePt(Angle1,StartPt,l);
 GetLinePt(Angle2,EndPt,l);


end;

procedure TFindObject.GetLinePt(Angle:double;Pt:PDPoint;item:Integer);
var
   Pt1,Pt2:TDPoint;
   m,Angle1,Angle2,r,r2,Tmp1,Tmp2:double;
begin

 Angle2:=(Angle+15.0)/57.29578;
 Angle1:=Angle/57.29578;

 r :=Fext.cx-(Fext.cx div item);
 r2:=Fext.cy-(Fext.cy div item);

 if r>r2 then  r:=r2;

 Pt1.x := cos(Angle1)*r+FCenter.x;
 Pt1.y := sin(Angle1)*r+FCenter.y;
 Pt2.x := cos(Angle2)*r+FCenter.x;
 Pt2.y := sin(Angle2)*r+FCenter.y;



 if (Angle>=180) AND (Angle<=360) then
 begin
    Tmp1:=Pt2.x;
    Tmp2:=Pt2.y;
    Pt2.x:=Pt1.x;   Pt1.x:=Tmp1;
    Pt2.y:=Pt1.y;   Pt1.y:=Tmp2;
 end;

 m:=(Pt1.y-Pt2.y)/(Pt1.x-Pt2.x);

 ReadLien(m,@Pt1,@Pt2);
 Pt^.x:=(Pt2.x+Pt1.x) / 2.0;
 Pt^.y:=(Pt2.y+Pt1.y) / 2.0;

// color.Red    := 255 ;
// color.Green  := 0   ;
// color.Blue   := 0   ;
// color.Overlay:= 0   ;

// rect.Left    := Round(pt1.x);
// rect.Top     := Round(pt1.y);
// rect.Right   := Round(pt2.x);
// rect.Bottom  := Round(pt2.y);

// FCartonObject.ShowArea.Line(rect,1,color);


end;

procedure TFindObject.ReadLien(m:double;Pt1,Pt2:PDPoint);
Var
   x,y,PreX,PreY,c:WORD;
   m1,m2,f:double;

   Color,r,g,b:WORD;
   bw:BYTE;
begin
   c:=0;

  if Fext.cx>=150 then
  begin
     m1:=1;
     m2:=1;
  end
  else
  begin
     m1:=abs(m);
     m2:=(1/m);
  end;

  PreX:=Round(Pt1^.x);
  PreY:=Round(Pt1^.y);
  while TRUE  do
  begin

      if m1<=1 then
       begin
       Pt1^.x:=Pt1^.x+1;
       Pt1^.y:=Pt1^.y+m;
       end
      else
       begin
        Pt1^.y:=Pt1^.y-1;
        Pt1^.x:=Pt1^.x-m2;
       end;

       x:=Round(Pt1^.x);
       y:=Round(Pt1^.y);

      if (x <> PreX) OR (y<>PreY)  then
       begin

        COLOR:=READPIXEL(x,y);

         if ((x<=FColorFrequence.Bounds.left) OR (x>=FColorFrequence.Bounds.right ))  OR
            ((y<=FColorFrequence.Bounds.top ) OR (y>=FColorFrequence.Bounds.bottom))  OR
            (COLOR=FextColor)
            then
            begin
             INC(c);
             break;
            end;

        R:= (COLOR and $f800) shr 11 ;
        G:= (COLOR and $07e0) shr 6  ;
        B:= (COLOR and $001f) ;
        COLOR:=((R+G+B) div 3) and $1f;
        BW:=COLOR;

         if bw < FMidTHR then  bw:=VP_BLACK
         else                  bw:=VP_WHITE;

         if bw=FCmpColor then
         begin
         INC(c);
         end
         else                 c:=0;

         PreX:=x;
         PreY:=y;
       end;
  end;

  if m1<=1 then
   begin
   Pt1^.x:=Pt1^.x-c;
   Pt1^.y:=Pt1^.y-(m*c);
   end
  else
   begin
   Pt1^.y:=Pt1^.y+c;
   Pt1^.x:=Pt1^.x+(m2*c);
   end;


  PreX:=Round(Pt2^.x);
  PreY:=Round(Pt2^.y);
  c:=0;
  while TRUE  do
   begin
     if m1<=1 then
      begin
       Pt2^.x:=Pt2^.x-1;
       Pt2^.y:=Pt2^.y-m;
      end
     else
      begin
       Pt2^.y:=Pt2^.y+1;
       Pt2^.x:=Pt2^.x+m2;
      end;

     x:=Round(Pt2.x);
     y:=Round(Pt2.y);

    if(x<>PreX) OR (y<>PreY)   then
     begin


        COLOR:=READPixel(x,y);

       if ((x<=FColorFrequence.Bounds.left) OR (x>=FColorFrequence.Bounds.right))   OR
          ((y<=FColorFrequence.Bounds.top)  OR (y>=FColorFrequence.Bounds.bottom))  OR
            (COLOR=FextColor)
          then
          begin
            INC(c);
            break;
          end;


        R:= (COLOR and $f800) shr 11 ;
        G:= (COLOR and $07e0) shr 6  ;
        B:= (COLOR and $001f) ;
        COLOR:=((R+G+B) div 3) and $1f;
        BW:=COLOR;



       if bw < FMidTHR then  bw:=VP_BLACK
       else                  bw:=VP_WHITE;


       if bw = FCmpColor  then
       begin
        INC(c);
       end
       else    c:=0;

      PreX:=x;
      PreY:=y;
     end;
  end;


  f:=c;
  if m1<=1 then
   begin
    Pt2^.x:= Pt2^.x+f;
    Pt2^.y:= Pt2^.y+(m*f);
   end
  else
   begin
   Pt2^.y:= Pt2^.y-f;
   Pt2^.x:= Pt2^.x-(m2*f);
   end;


end;

function TFindObject.MoncLine(StartPt,EndPt:PDPoint):double;
var
  x,y:double;
begin
 y:=(EndPt^.y-StartPt^.y);
 x:=(EndPt^.x-StartPt^.x);

 if x=0 then       result:=0
 else if y=0 then  result:=0
 else              result:=y/x;

end;



function handleCenters(CenterList:TList):double;
var
   i,j,k,c,i2:integer;
   item1,item2:PDouble;
   l:double;
   center:double;
begin


  i:=0;
  j:=CenterList.Count-1;
  while  i<j do
  begin
    item1:=CenterList.Items[i];
    item2:=CenterList.Items[i+1];

    if (item1^-item2^) >= 10 then
    begin
      if j=(CenterList.Count-1) then DEC(j);

      CenterList.Delete(i);
    end
    else  INC(i);


   if  j>i then
    begin
     item1:=CenterList.Items[j] ;
     item2:=CenterList.Items[j-1];
     if (item2^-item1^) >= 10 then  CenterList.Delete(j);
     DEC(j);
    end;


  end;

  c:=CenterList.Count div 3*2;
  i:=0;
  k:=0;
  i2:=CenterList.Count-1;

  while i<i2  do
  begin
        item1:=CenterList.Items[i];

        for j:=0 to CenterList.Count-1 do
        begin
            item2:=CenterList.Items[j];
            l:=(item1^-item2^);
            if l<0 then l:=-l;
            if l<1 then INC(k);
        end;

        if k<c then
        begin
           if i2=(CenterList.Count-1) then DEC(i2);
           CenterList.Delete(i);

           DEC(c);
           c :=(c div 3*2);
           if c<1 then c:=1;

        end
        else  INC(i);

        k:=0;

        if i2>i then
         begin
            item1:=CenterList.Items[i2];

            for j:=(CenterList.Count-1) downto 0 do
             begin
                item2:=CenterList.Items[j];
                l:=item1^-item2^;
                if l<0 then  l:=-l;
                if l<1 then  INC(k);
             end;

            if k<c then
             begin
              CenterList.Delete(i2);
              DEC(c);
              c:=c div 3*2;
              if c<1 then c:=1;
             end;

            k:=0;
            DEC(i2);

       end;

  end;

  center:=0;
  i:=CenterList.Count;
  if i>0 then
  begin
   for j:=0 to (i-1) do
      center:=center+PDouble(CenterList.Items[j])^;

   center:=center/i;
  end;

  result:=center;

end;

end.
