unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, VideoCapture, StdCtrls,VFW_SDK,VCapDescription,TowValueBox,
  CommonUnit,ReadRGBBox;

type
  TForm1 = class(TForm)
    VideoBox: TVideoCapture;
    VideoDriverBox: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    VideoStatusBox: TStaticText;
    Label3: TLabel;
    VideoErrorBox: TStaticText;
    CapDescriptionBtn: TButton;
    VideoSourceBtn: TButton;
    VideoFormatBtn: TButton;
    VExtDisplayButton: TButton;
    VCompressionButton: TButton;
    SaveBMPButton: TButton;
    TowValueButton: TButton;
    READRGBButton: TButton;
    procedure FormCreate(Sender: TObject);
    procedure VideoDriverBoxChange(Sender: TObject);
    procedure VideoBoxError(sender: TObject; nID: Integer;
      errorstr: String);
    procedure VideoBoxStatus(Sender: TObject);
    procedure VideoBoxStatusCallback(Sender: TObject; nID: Integer;
      status: String);
    procedure FormShow(Sender: TObject);
    procedure CapDescriptionBtnClick(Sender: TObject);
    procedure VideoSourceBtnClick(Sender: TObject);
    procedure VideoFormatBtnClick(Sender: TObject);
    procedure VExtDisplayButtonClick(Sender: TObject);
    procedure VCompressionButtonClick(Sender: TObject);
    procedure SaveBMPButtonClick(Sender: TObject);
    procedure TowValueButtonClick(Sender: TObject);
    procedure READRGBButtonClick(Sender: TObject);
  private
    { Private declarations }
     procedure WMChangVideoBoxParent(var Message: TMessage); message   WM_ChangVideoBoxParent;
     procedure WMReleaseVideoBoxParent(var Message: TMessage); message WM_WMReleaseVideoBoxParent;



  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.WMChangVideoBoxParent(var Message: TMessage);
var
h:HWND;
begin
 h:=HWND(Message.WParam);
 windows.SetParent(VideoBox.Handle,h);
end;

procedure TForm1.WMReleaseVideoBoxParent(var Message: TMessage);
begin
 windows.SetParent(VideoBox.Handle,Handle);
end;





procedure TForm1.FormCreate(Sender: TObject);
Var DrvList:TStrings;
begin

 drvList:=  GetCaptureDriverList;
 VideoDriverBox.Items:= drvList;
 drvList.Clear;
 drvList.Free;
 VideoDriverBox.Itemindex:=VideoBox.DriverIndex;



end;

procedure TForm1.FormShow(Sender: TObject);
begin
  VideoBox.DriverOpen:= true;
  VideoBox.VideoPreview:=TRUE;


end;


procedure TForm1.VideoDriverBoxChange(Sender: TObject);
begin
 VideoBox.DriverOpen:= false;
 VideoBox.DriverIndex:=VideoDriverBox.Itemindex;
 VideoBox.DriverOpen:= true;

  VideoBox.VideoPreview:=TRUE;
end;

procedure TForm1.VideoBoxError(sender: TObject; nID: Integer;
  errorstr: String);
begin
  if nid=0 then exit;

  VideoErrorBox.Caption:=CAPIDSToStr(nid)+':'+ errorstr;

end;

procedure TForm1.VideoBoxStatus(Sender: TObject);
begin
//
 if (VideoBox.DriverIndex=-1) or (VideoBox.DriverOpen=FALSE) then
 begin
  CapDescriptionBtn.Enabled:=FALSE;
  VideoSourceBtn.Enabled:=false;
  VideoFormatBtn.Enabled:=false;
  VExtDisplayButton.Enabled:=false;
  VCompressionButton.Enabled:=false;
  SaveBMPButton.Enabled:=false;

 end
 else
 begin
  CapDescriptionBtn.Enabled:=TRUE;
  VideoSourceBtn.Enabled := VideoBox.HasDlgSource;
  VideoFormatBtn.Enabled := VideoBox.HasDlgFormat;
  VExtDisplayButton.Enabled:= VideoBox.HasDlgDisplay;
  VCompressionButton.Enabled:=True;
  SaveBMPButton.Enabled:=TRUE;
 end;



end;

procedure TForm1.VideoBoxStatusCallback(Sender: TObject; nID: Integer;
  status: String);
begin
  if nID =IDS_CAP_STAT_VIDEOCURRENT then exit;
  if nid=0 then exit;

  VideoStatusBox.Caption:= CAPIDSToStr(nid)+':' + status;


end;



procedure TForm1.CapDescriptionBtnClick(Sender: TObject);
begin
//

 if VideoBox.ReadDescription<>nil  then
 begin
   ShowVideoCaptureDescription(VideoBox);
 end
 else Beep;


end;

procedure TForm1.VideoSourceBtnClick(Sender: TObject);
begin
 if VideoBox.HasDlgSource then VideoBox.DlgVSource;
end;

procedure TForm1.VideoFormatBtnClick(Sender: TObject);
begin
 if VideoBox.HasDlgFormat then VideoBox.DlgVFormat;
end;

procedure TForm1.VExtDisplayButtonClick(Sender: TObject);
begin
  if VideoBox.HasDlgDisplay then VideoBox.DlgVDisplay;


end;


procedure TForm1.VCompressionButtonClick(Sender: TObject);
begin
  VideoBox.DlgVCompression;
end;

procedure TForm1.SaveBMPButtonClick(Sender: TObject);
var
bmp:Tbitmap;
begin

 bmp:=VideoBox.GetBitmap;
 if assigned(bmp) then
 begin
  bmp.SaveToFile('test.bmp');
  bmp.Free;
 end;

end;

procedure TForm1.TowValueButtonClick(Sender: TObject);
var
autoTHR:Boolean;
THR:BYTE;
begin

 autoTHR:=FALSE;
 THR:=0;
 ShowTowValueBox(VideoBox,autoTHR,THR);

end;


procedure TForm1.READRGBButtonClick(Sender: TObject);
begin

 ShowReadRGBBox(VideoBox);

end;

end.
