unit TowValueBox;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,VideoCapture, OwnerButton, ExtCtrls, CoolForm,
  CapFunction, ComCtrls, TeEngine, Series, TeeProcs, Chart,CommonUnit,
  OwnerRadio, Counter;

type
  TTowValueForm = class(TForm)
    CoolForm1: TCoolForm;
    VideoImage: TImage;
    CloseButton: TOwnerButton;
    TowValButton: TOwnerButton;
    Chart1: TChart;
    Series1: TBarSeries;
    Panel1: TPanel;
    Counter1: TCounter;
    AutoTHRButton: TOwnerCheck;
    Panel2: TPanel;
    TrackBar1: TTrackBar;
    procedure CloseButtonClick(Sender: TObject);
    procedure TowValButtonClick(Sender: TObject);
    procedure AutoTHRButtonClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { Private declarations }
    fVideoBox:TVideoCapture;

  public
    { Public declarations }
  end;

var
  TowValueForm: TTowValueForm;

  procedure ShowTowValueBox(aVideoBox:TVideoCapture;var aAUTOTHR:BOOLEAN;var aTHR:BYTE);


implementation

{$R *.dfm}


procedure ShowTowValueBox(aVideoBox:TVideoCapture;var aAUTOTHR:BOOLEAN;var aTHR:BYTE);
var
h1:HWND;
begin
 TowValueForm:= TTowValueForm.Create(nil);

 with TowValueForm do
 begin
  fVideoBox:=aVideoBox;

  VideoImage.Picture.Bitmap.Width :=fVideoBox.Width;
  VideoImage.Picture.Bitmap.Height:=fVideoBox.Height;
  VideoImage.Picture.Bitmap.PixelFormat:=pf16bit;
  fVideoBox.GetBitmap(VideoImage.Picture.Bitmap);
 end;


   TowValueForm.AutoTHRButton.Checked := aAUTOTHR;
   TowValueForm.TrackBar1.Position:=aTHR;


  if  TowValueForm.AutoTHRButton.Checked=FALSE then
  begin
     TowValueForm.Panel2.Enabled:=TRUE;
  end;



  h1:= TowValueForm.Panel1.Handle;
  SendMessage(application.MainForm.Handle,WM_ChangVideoBoxParent,h1,0);
  TowValueForm.ShowModal;
  SendMessage(application.MainForm.Handle,WM_WMReleaseVideoBoxParent,0,0);

  aTHR:= TowValueForm.TrackBar1.Position;
  aAUTOTHR:= TowValueForm.AutoTHRButton.Checked;

  TowValueForm.Free;








end;





procedure TTowValueForm.CloseButtonClick(Sender: TObject);
begin
 Close;
end;

procedure TTowValueForm.TowValButtonClick(Sender: TObject);
var
f:TColorFrequence;
r:TRECT;
buf:array [0..31]  of double;
i:integer;
begin



 fVideoBox.GetBitmap(VideoImage.Picture.Bitmap);
 f:=TColorFrequence.Create(fVideoBox,VideoImage.Picture.Bitmap);

 f.AutoTHR:=AutoTHRButton.Checked;
 r.Left  := 0 ;
 r.Top   := 0 ;
 r.Right := fVideoBox.Width-1;
 r.Bottom:= fVideoBox.Height-1;
 f.Bounds:= r;
 f.ColorStatistic;


 for i:=0 to 31 do
 begin
  buf[i]:=f.ColorBuf[i];
 end;
 Series1.Clear;
 Series1.AddArray(buf);

 f.DrawBW;

 if AutoTHRButton.Checked=TRUE then  TrackBar1.Position:=f.THR;

 f.Free;

 VideoImage.Invalidate;


end;

procedure TTowValueForm.AutoTHRButtonClick(Sender: TObject);
begin


  if AutoTHRButton.Checked=TRUE then
  begin
     Panel2.Enabled:=FALSE;
  end
  else
  begin
     Panel2.Enabled:=TRUE;
  end;

end;

procedure TTowValueForm.TrackBar1Change(Sender: TObject);
begin
 Counter1.Value := TrackBar1.Position;
end;

end.
